/*
Chapter -3 
Project - 10 Autoranging frequency counter

*/

#include<avr/io.h>
#include<avr/pgmspace.h>
#include<avr/interrupt.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include"C25Ddisplay.h"



unsigned char call(unsigned char n);
//This function maps the digits to statusonoff array
void display(unsigned char digit1,unsigned char digit2,unsigned char digit3,unsigned char point,unsigned char minus);
		 
volatile unsigned char count=0,statusonoff[20];
//										  m,b,c,p, a,b,c,d,e,f,g,p,a,b,c,d,e,f,g,p								
const unsigned char anode[20]PROGMEM  = {4,4,4,4,2,2,2,2,3,3,3,3,0,0,0,0,1,1,1,1};
const unsigned char cathode[20]PROGMEM ={3,0,1,2,0,1,3,4,0,1,2,4,1,2,3,4,0,2,3,4};

const unsigned char digit_map[16] PROGMEM =
{
	SEVEN_SEGMENT_PATTERN_0,
	SEVEN_SEGMENT_PATTERN_1,
	SEVEN_SEGMENT_PATTERN_2,
	SEVEN_SEGMENT_PATTERN_3,
	SEVEN_SEGMENT_PATTERN_4,
	SEVEN_SEGMENT_PATTERN_5,
	SEVEN_SEGMENT_PATTERN_6,
	SEVEN_SEGMENT_PATTERN_7,
	SEVEN_SEGMENT_PATTERN_8,
	SEVEN_SEGMENT_PATTERN_9,
	SEVEN_SEGMENT_PATTERN_A,
	SEVEN_SEGMENT_PATTERN_b,
	SEVEN_SEGMENT_PATTERN_C,
	SEVEN_SEGMENT_PATTERN_d,
	SEVEN_SEGMENT_PATTERN_E,
	SEVEN_SEGMENT_PATTERN_F,
};



//Counts Rising and Falling Edges
volatile unsigned int edgecounter=0;

//Number of pulses counted in one second
volatile unsigned int pulsespersec=0;

//gating counter variable for clocking 1 second
volatile unsigned int gating=0;


volatile unsigned char point,c,d,e;

int main(void)
{

	//Timer Init
	TCCR0A = 0x00;
	TCCR0B = 0x02;//prescaled by 8, so frequency = 1MHz
	TIMSK =  0x02;//Timer/Counter0 Overflow Interrupt Enable is set

	GIMSK = 0b00100000; //Pin Change Interrupt Enable is Set
	PCMSK = 0b00100000;	//Triggers Interrupts only on Change on Pin 5
	
	TCNT0 = 6;// so that interrupt frequency is  1MHz/(256-6) = 4000Hz
	
	sei();
	
	
	
	while(1)
	{
		
		if(gating==4000)
		{
			gating=0;
			pulsespersec=edgecounter>>1;
			edgecounter=0;
		
		
			//we have the actual frequency here
		
			if(pulsespersec<=199)
			{
				point = 3;
			}
			else if(pulsespersec<1999)
			{
				if(pulsespersec%10>=5)
				{
					pulsespersec = pulsespersec +10;
				}
				pulsespersec = pulsespersec/10;
				point = 2;//just to display and not actual decimal
			}
			else if(pulsespersec<19999)
			{
				
				if(pulsespersec%100>=50)
				{
					pulsespersec = pulsespersec +100;
				}
				pulsespersec = pulsespersec/100;
				point = 1;
			}
			
			c=pulsespersec/100;
			pulsespersec = pulsespersec%100;
			d= pulsespersec/10;
			pulsespersec = pulsespersec%10;
			e = pulsespersec;
			
			display(c,d,e,point,0);
		}
		
		

	}

	

}


//Overflow routine for timer0, called 4000 times a second
ISR(TIM0_OVF_vect)
{
	TCNT0 = 6;// so that interrupt frequency is  1MHz/(256-6) = 4000Hz
	DDRB = 0;
	
	PORTB = 1<<pgm_read_byte(&anode[count])|(call(count))<<pgm_read_byte(&cathode[count]);
	DDRB = 1<<pgm_read_byte(&anode[count])|1<<pgm_read_byte(&cathode[count]);
	count++;
	if(count==20)
	count=0;
	
	gating++;
	
}

ISR(PCINT0_vect)
{
	edgecounter++;
}

//This function checks whether the led should be switched on or off when its turn comes
unsigned char call(unsigned char n)
{
	unsigned char j;
	j = statusonoff[n];
	j = ~j;
	j = j&(1<<0); //Extract LSB
	return j;
}


//This function maps the digits to statusonoff array
void display(unsigned char digit1,unsigned char digit2,unsigned char digit3,unsigned char point,unsigned char minus)
{
	
	unsigned char i;
	statusonoff[0]=minus;
	statusonoff[1]=digit1;
	statusonoff[2]=digit1;
	statusonoff[3]=(point==1);
	
	for(i=0;i<8;i++)
	{
		statusonoff[4+i]= ((pgm_read_byte(&digit_map[digit2]))&(1<<i))>>i;
		statusonoff[12+i]= ((pgm_read_byte(&digit_map[digit3]))&(1<<i))>>i;	
	}
	statusonoff[11]= (point==2);
	statusonoff[19]= (point==3);
	
}


