/*
Chapter 3
Project 12 RGB Dice
*/


/*
Led selection
statusonoff 
            0 = led 1
			1 = led 3
			2 = led 5
			3 = led 7

coloronoff 0 = Green
           1 = Blue
		   2 = Red  


*/


//Include Files
#include<avr/io.h>
#include<avr/interrupt.h>
#include<avr/pgmspace.h>
#define F_CPU 9600000UL
#include<util/delay.h>

//Global Variables


volatile unsigned char i=0,statusonoff[5],coloronoff[3],l;
volatile unsigned char anode[12]  PROGMEM= {1,1,1,2,2,2,3,3,3,4,4,4};//Anodes of the LEDs on PORTB
volatile unsigned char cathode[12]PROGMEM= {4,2,3,4,1,3,4,1,2,3,1,2};//Cathodes of the LEDs on PORTB
																	   //Given in sequence of Green,Blue,Red, i.e color array
//color array specifies which variable of coloronoff should be checked to determine the state of each LED
volatile unsigned char color[12] PROGMEM= {0,1,2,0,1,2,0,1,2,0,1,2};//color variables corresponding to 0,1 2 of color on off

//On similar lines status array to decide which variable of statusonoff shall be checked for each LED
//is not required because anode array can be used instead .
//For this statusonoff is declared to be an array of 5 characters so that we can use 1,2,3,4 position characters of
//statusonoff array which can be indicated directly by anode array instead of a new status array. statusonoff[0] is never used
void switchpressed(void);
void switchreleased(void);
unsigned char call(unsigned char n,unsigned char m);



int main(void)
{


	sei(); //Global Interrupt enable

	//Timer settings
	TCCR0A = 0x00;
	TCCR0B = 0x02;
	TIMSK0 = 0x02;

	DDRB &= (~(1<<0));//Switch input declared
	PORTB |= (1<<0);//Pull up enabled

	while(1)
	{
		switchpressed();
		switchreleased();
	}

	
}


//subroutine for switch pressed
void switchpressed(void)
{
	unsigned char b = 1;
	while((PINB&(1<<0))) //wait for switch to get pressed
	{
		
		if(b==6)
		b = 1;
		else
		b = b+1;
		
	}
	_delay_ms(20); //to prevent bounce
	statusonoff[1]= (b==4)||(b==5)||(b==6);
	statusonoff[2]= (b==4)||(b==5)||(b==6)||(b==3);
	statusonoff[3]= (b==2)||(b==6);
	statusonoff[4]= (b==1)||(b==3)||(b==5);
	

}

//subroutine for switch released
void switchreleased(void)
{
	
	unsigned char b = 1;
	while(!(PINB&(1<<0))) //wait for switch to get released
	{
		
		if(b==6)
		b = 1;
		else
		b = b+1;
	}
	_delay_ms(20); //to prevent bounce
	
	coloronoff[0]=(b==2)||(b==4)||(b==6);
	coloronoff[1]=(b==3)||(b==4)||(b==5);
	coloronoff[2]=(b==1)||(b==6)||(b==5);
	
	
}


ISR(TIM0_OVF_vect) //Interrupt Subroutine
{
	
	DDRB = 0;
	l = call(pgm_read_byte(&anode[i]),pgm_read_byte(&color[i]));

	PORTB = l<<pgm_read_byte(&anode[i])|0<<pgm_read_byte(&cathode[i])|1<<0;
	DDRB =  l<<pgm_read_byte(&anode[i])|l<<pgm_read_byte(&cathode[i]);

	i++;
	if(i==12)
	i=0;
}


unsigned char call(unsigned char n,unsigned char m)
{
	unsigned char k;
	k = (statusonoff[n])&&(coloronoff[m]);
	return k;
}
