/*

Chapter - 3
Project-13 RGB Tic-Tac-Toe
*/



/*
Game of Tic Tac Toe to be played with RGB Leds 
producing sixteen different colour combinations

Led Arrangement on PCB along with associated variables
  
B    	R   	G	        B	    R	    G    	  B  	  R 	  G  
i[6][0],i[6][1],i[7][2]     i[7][0],i[7][1],i[7][2]   i[8][0],i[8][1],i[8][2] 

i[3][0],i[3][1],i[3][2]     i[4][0],i[4][1],i[4][2]   i[5][0],i[5][1],i[5][2]  

i[0][0],i[0][1],i[0][2]     i[1][0],i[1][1],i[1][2]   i[2][0],i[2][1],i[2][2]  

 

 Magic Square
   
8     1     6     Sum of each,row and diagonal is 15
3     5     7     
4     9     2     


*/



//Header files
#include<avr/io.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include<avr/interrupt.h>


//Global Variables
volatile int o=0;
volatile unsigned char d=0,enable=0;
volatile unsigned char r1=0,r2=0,g1=0,g2=0,b1=0,b2=0;
volatile unsigned char i[9][3],ix[9][3],e=0,e1=0,e2=0;
volatile unsigned char statusledbrg[3],e3=0;
volatile unsigned char q,z[9],tu;
volatile unsigned char r[9];
volatile unsigned char k[16]={7,6,2,5,4,7,9,1,5,2,6,4,0,9,0,9};//blue
volatile unsigned char l[16]={5,5,3,3,7,2,3,4,6,3,0,5,0,0,9,9};//red
volatile unsigned char m[16]={9,6,4,2,1,0,4,9,1,4,2,1,0,9,9,0};//green
volatile unsigned char magic[9] = {8,1,6,3,5,7,4,9,2};
volatile unsigned char pc1=0,pc2=0;
volatile unsigned char p1data[5],p2data[5];

volatile unsigned char switch_1_pressed=0,switch_1_released=0,switch_2_pressed=0;
volatile unsigned char switch_2_released=0,switch_3_pressed=0,switch_3_released=0;



//Function prototypes
void start(unsigned char  player);
void xyz(void);
void abc(unsigned char a1,unsigned char a2,unsigned char a3,unsigned char a4,unsigned char a5,unsigned char a6,unsigned char a7,unsigned char a8,unsigned char a9,unsigned char compare);
void playerturn(unsigned char blue,unsigned char red,unsigned char green,unsigned char player1);
void clear(void);
void reset(void);
void checkwin(void);
void win(unsigned char player2);
void abc1(void);


int main(void)
{

	

	//Port Initialisation
	DDRA= 0xff;
	DDRB = 0x3f;
	
	PORTA = 0xff;
	PORTB = 0xff;
	
	//Timer Initialisation
	sei();
	
	TCCR0A = 0x00;
	TCCR0B = 0x01;//No prescaling


	TCCR1A = 0x00;
	TCCR1B = 0x0c;//Prescale by 16384
	

	TIMSK = 1<<TOIE0;//Overflow interrupt Enabled
	
	reset();

	start(1);
	start(2);
	TIMSK|=  1<<TOIE1;//Overflow interrupt enabled
	while(1)
	{
		playerturn(b1,r1,g1,1);
		checkwin();
			
		playerturn(b2,r2,g2,2);
		checkwin();
		
	}
		
	
	
}


//Main over start definition of functions


void start(unsigned char player)
{
	
	while(1)
	{

		if(switch_1_released == 1)
		{
			switch_1_pressed = 0;
			switch_1_released = 0;
			o++;
			if(o==16)
			o=0;
		}

		if(switch_2_released == 1)
		{
			switch_2_pressed = 0;
			switch_2_released = 0;
			
			o--;
			if(o==-1)
			o=15;
		}

		for(tu=0;tu<9;tu++)
		{
			i[tu][0]=k[o];
			i[tu][1]=l[o];
			i[tu][2]=m[o];
		}
		
		if(switch_3_released == 1)
		{
			switch_3_pressed = 0;
			switch_3_released = 0;

			if(player == 1)
			{ 	
				r1 = l[o]; b1 =k[o]; g1 = m[o];
				l[o]=4;k[o]=6;m[o]=2;
			}
			else if(player == 2)
			{ 
				r2 = l[o];b2 = k[o]; g2 = m[o];
				
			}

			for(tu=0;tu<9;tu++)
			{
				i[tu][0]=9;
				i[tu][1]=9;
				i[tu][2]=9;
			}
			
			break;
		}
	}
}

void playerturn(unsigned char blue,unsigned char red,unsigned char green,unsigned char player1)
{
	statusledbrg[0]=blue;
	statusledbrg[1]=red;
	statusledbrg[2]=green;

	//For proper placement
	q = 4;
	
	for(;r[q]==magic[q];)
	{
		q++;
		if(q==9)
		q=0;
	}
	clear();
	ix[q][0]=blue;ix[q][1]=red;ix[q][2]=green;
	

	for(;;)
	{


		if(switch_1_released == 1)
		{
			switch_1_released = 0;
			switch_1_pressed = 0;
			
			q++;
			if(q==9)
			q=0;
			for(;r[q]==magic[q];)
			{
				q++;
				if(q==9)
				q=0;
			}
			
			clear();
			ix[q][0]=blue;ix[q][1]=red;ix[q][2]=green;
			
		}

		if(switch_2_released == 1)
		{
			
			switch_2_released = 0;
			switch_2_pressed = 0;
			
			q = q+3;
			if(q==9||q==10)
			q=q-8;
			if(q==11)
			q = 0;
			for(;r[q]==magic[q];)
			{
				q = q+3;
				if(q==9||q==10)
				q=q-8;
				if(q==11)
				q = 0;
			}
			clear();
			ix[q][0]=blue;ix[q][1]=red;ix[q][2]=green;
			
		}

		if(switch_3_released == 1)
		{

			switch_3_released = 0;
			switch_3_pressed = 0;
			r[q]=magic[q];//Assign position

			if(player1==1)
			{
				p1data[pc1] = magic[q];
				pc1++;
			}
			else if(player1==2)
			{
				p2data[pc2] = magic[q];
				pc2++;
			}

			break;
		}

	}
}


ISR(TIMER0_OVF_vect)
{
	d++;
	if(d==5)
	{
		DDRA= 0x00;
		DDRB = 0x00;
		PORTB |= (1<<1);
		PORTB |= (1<<2);
		PORTB |= (1<<3);
		PORTB |= (1<<4);
		
		if(enable>=0&&enable<=8)
		{
			
			if(e==9)
			{
				e=0;
				xyz();
			}
			abc(i[0][0],i[0][1],i[0][2],i[3][0],i[3][1],i[3][2],i[6][0],i[6][1],i[6][2],e);
			PORTB &= ~(1<<3);
			e++;
		}
		else if(enable>=9&&enable<=17) 
		{
			
			if(e1==9)
			{
				e1=0;
				xyz();
			}
			abc(i[1][0],i[1][1],i[1][2],i[4][0],i[4][1],i[4][2],i[7][0],i[7][1],i[7][2],e1);
			PORTB &= ~(1<<2);
			e1++;
		}
		else if(enable>=18&&enable<=26)
		{
			if(e2==9)
			{
				e2=0;
				xyz();
			}
			abc(i[2][0],i[2][1],i[2][2],i[5][0],i[5][1],i[5][2],i[8][0],i[8][1],i[8][2],e2);
			PORTB &= ~(1<<1);
			e2++;
		}
		else if(enable>=27&&enable<=35)
		{
			if(e3==9)
			{
				e3=0;
				xyz();
			}
			abc1();
			PORTB &= ~(1<<4);
			e3++;
		}
		enable++;
		if(enable==36)
		enable=0;
		DDRA= 0xff;
		DDRB = 0x3f;
		
		d=0;
	}
	if(((PORTB&0x02)==0)&&((DDRB&0x02)==0x02)) //If PB1 declared as output and equal to zero
	{
		
		if(!(PINB&0x40))
		{
			switch_1_pressed = 1;
		}
		if(((PINB&0x40)==0x40)&&(switch_1_pressed==1))
		{
			switch_1_released = 1;
			
		}
		
	}
	if(((PORTB&0x04)==0)&&((DDRB&0x04)==0x04)) //If PB2 declared as output and equal to zero
	{
		
		if(!(PINB&0x40))
		{
			switch_2_pressed = 1;
		}
		if(((PINB&0x40)==0x40)&&(switch_2_pressed==1))
		{
			switch_2_released = 1;
			
		}
		
	}
	if(((PORTB&0x08)==0)&&((DDRB&0x08)==0x08)) //If PB3 declared as output and equal to zero
	{
		
		if(!(PINB&0x40))
		{
			switch_3_pressed = 1;
		}
		if(((PINB&0x40)==0x40)&&(switch_3_pressed==1))
		{
			switch_3_released = 1;
			
		}
		
	}
}

ISR(TIMER1_OVF_vect)
{
	
		for(tu=0;tu<9;tu++)
		{
			if(r[tu]!=magic[tu])
			{
				if(z[tu]==0)
				{
					i[tu][0]=ix[tu][0];i[tu][1]=ix[tu][1];i[tu][2]=ix[tu][2];
					z[tu]=1;
				}
				else if(z[tu]==1)
				{
					i[tu][0]=9;
					i[tu][1]=9;
					i[tu][2]=9;
					z[tu]=0;
				}
			}
			else
			{
				i[tu][0]=ix[tu][0];i[tu][1]=ix[tu][1];i[tu][2]=ix[tu][2];
			}
		}
	
}


void abc1(void)
{
	if(e3==statusledbrg[0])
	{
		PORTB = PORTB&~(0b00000001);
	}
	if(e3==statusledbrg[1])
	{
		PORTA = PORTA&~(0b10000000);
	}
	if(e3==statusledbrg[2])
	{
		PORTA = PORTA&~(0b01000000);
	}
	
	
}

void abc(unsigned char a1,unsigned char a2,unsigned char a3,unsigned char a4,unsigned char a5,unsigned char a6,unsigned char a7,unsigned char a8,unsigned char a9,unsigned char compare)
{

	if(compare==a1)
	{
		PORTA = PORTA&~(0b00000100);
	}
	if(compare==a2)
	{
		PORTA = PORTA&~(0b00000010);
	}
	if(compare==a3)
	{
		PORTA = PORTA&~(0b00000001);
	}
	if(compare==a4)
	{
		PORTA = PORTA&~(0b00100000);
	}
	if(compare==a5)
	{
		PORTA = PORTA&~(0b00010000);
	}
	if(compare==a6)
	{
		PORTA = PORTA&~(0b00001000);
	}
	if(compare==a7)
	{
		PORTB = PORTB&~(0b00000001);
	}
	if(compare==a8)
	{
		PORTA = PORTA&~(0b10000000);
	}
	if(compare==a9)
	{	
		PORTA = PORTA&~(0b01000000);
		
		
	}
}

void xyz(void)
{
	PORTA = PORTA|((1<<0))|((1<<1))|((1<<2));
	PORTA = PORTA|((1<<3))|((1<<4))|((1<<5));
	PORTA = PORTA|((1<<6))|((1<<7)); PORTB = PORTB|((1<<0));
}

void clear(void)
{

	for(tu=0;tu<9;tu++)
	{
		if(r[tu]!=magic[tu])
		{
			ix[tu][0]=9;
			ix[tu][1]=9;
			ix[tu][2]=9;
		}
		
	}
		
}

void win(unsigned char player2)
{

	
	PORTB &=~(1<<5);
	_delay_ms(500);
	PORTB |= 1<<5;

	while(1)
	{
		if(switch_3_released==1)
		{
			switch_3_pressed=0;
			switch_3_released=0;
			break;
		}
	}
	reset();
}

void reset() //Clear everything except r1 r2 b1 b2 g1 g2 
{

	for(tu=0;tu<9;tu++)
	{
		i[tu][0]=9;
		i[tu][1]=9;
		i[tu][2]=9;
		ix[tu][0]=9;
		ix[tu][1]=9;
		ix[tu][2]=9;
		r[tu]=0;
	}

	q=0;pc1=0;pc2=0;
	p1data[0]=16;p1data[1]=16;p1data[2]=16;p1data[3]=16;p1data[4]=16;
	p2data[0]=16;p2data[1]=16;p2data[2]=16;p2data[3]=16,p2data[4]=16;
	statusledbrg[0]= 9;statusledbrg[1]=9;statusledbrg[2]=9;
}

void checkwin()
{


	int klm=0;
	int mkg=0;

	//CHECK player 1 win

	for(int wb=0;wb<=2;wb++)
	{
		for(int wb1=wb+1;wb1<=4;wb1++)
		{
			for(int wb2=wb1+1;wb2<=4;wb2++)
			{
				if(p1data[wb]+p1data[wb1]+p1data[wb2]==15)
				{
					klm=1;
					//for blinking correct leds
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p1data[wb]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p1data[wb1]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p1data[wb2]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					break;
				}
			}
			if(klm==1)
			break;
		}
		if(klm==1)
		break;
	}

	//player1 has won
	if(klm==1)
	{
		win(1);
		return;
	}

	//check player 2 win
	for(int wb=0;wb<=2;wb++)
	{
		for(int wb1=wb+1;wb1<=4;wb1++)
		{
			for(int wb2=wb1+1;wb2<=4;wb2++)
			{
				if(p2data[wb]+p2data[wb1]+p2data[wb2]==15)
				{
					mkg=1;
					//for blinking correct leds
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p2data[wb]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p2data[wb1]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					for(int qwer=0;qwer<9;qwer++)
					{
						if(p2data[wb2]==magic[qwer])
						{
						r[qwer]=0;
						break;
						}
					}
					break;
				}
			}
			if(mkg==1)
			break;
		}
		if(mkg==1)
		break;
	}

	//player 2 has won
	if(mkg==1)
	{
		win(2);
		return;
	}
	
	//Noone has won and game has to be over
	if(((pc1==5)&&(pc2==4))||((pc1==4)&&(pc2==5)))
	reset();

}



