#ifndef RTC_H
    #define RTC_H

#define S1_DDR DDRA
#define S1_PORT PORTA
#define S1_PIN PINA
#define S2_DDR DDRB
#define S2_PORT PORTB
#define S2_PIN PINB

#define S1 2
#define S2 6

extern const char table1[];
extern const char table2[];

/***************************************
Rtc structure consisting of:
start: First value to be read from progmem while displaying data
end  : Last value to be read from progmem while displaying data
x    : Used to display data pattern when end reaches table limit
row  : Display page of corresponding quantity
c    : Timer count of corresponding quantity    
***************************************/
typedef struct rtc
{
    volatile unsigned int start, end, x, row, c;
}rtcpara;

//global variables
rtcpara s,m,h,d;//structure for seconds, minutes, hours, days
volatile unsigned int column,i;

//RTC prototypes
void boxes(void);
void centerline(void);
void seconds(void);
void minutes(void);
void hours(void);
void days(void);
void timer0init(void);
void extinit(void);
void settime(volatile unsigned int,volatile unsigned int,volatile unsigned int);

#endif
