/*
	Chapter 4
	Project 18 Zany Clock
*/



#include<avr/io.h>
#include<avr/pgmspace.h>
#define F_CPU 7372800UL
#include<util/delay.h>
#include<avr/interrupt.h>
#include"lcd.h"
#include"rtc.h"

//global variables
volatile unsigned int page=1,dd=1,hh,mm;
volatile unsigned char count,check;

int main(void)
{  
    //declaring pins as output for switches
    S1_DDR &= ~(1<<S1);//Input declared
    S1_PORT |= (1<<S1);//Pull up Enabled
    S2_DDR &= ~(1<<S2);//Input declared
    S2_PORT |= (1<<S2);//Pull up Enabled
   
    initlcd();    		//initializes LCD
    cursorxy(15,1);		//startup message
    putstr("Welcome to");
    cursorxy(19,3);
    putstr("TIMELINE");
    cursorxy(0,5);
    putstr("Press any key");

    while((S1_PIN&(1<<S1))&&(S2_PIN&(1<<S2)));//wait
	_delay_ms(20);
	while(!((S1_PIN&(1<<S1)))||(!(S2_PIN&(1<<S2))));//wait
	_delay_ms(20);
	
    clearram();			//clear LCD


    cursorxy(0,1);		//setup message and time setting instruction
    putstr("Set time & day");

    cursorxy(0,2);
    putstr("Key 1:Inc");

    cursorxy(0,3);
    putstr("Key 2:Set");

    cursorxy(0,5);
    putstr("Press any key");
	
	while((S1_PIN&(1<<S1))&&(S2_PIN&(1<<S2)));//wait
	_delay_ms(20);
	while(!((S1_PIN&(1<<S1)))||(!(S2_PIN&(1<<S2))));//wait
	_delay_ms(20);
	
    clearram();


    cursorxy(19,1);		//display hour, min and day
    putstr("Hour : ");

    cursorxy(19,3);
    putstr("Min  : ");

    cursorxy(19,5);
    putstr("Day  : "); 
	
	while(1)
    {
        if(!(S1_PIN&(1<<S1)))			//if Switch1 is pressed
        {
            _delay_ms(20);				//debounce
            while(!(S1_PIN&(1<<S1)));	//wait till released
            _delay_ms(20);				//debounce
			
			if(page==1)					//check hour page
			{
			    if(hh==23)				//inc hour 
			    hh=0;
			    else
			    hh++;
            }
			
			if(page==3)					//check min page
			{
			    if(mm==59)				//inc min 
			    mm=0;
			    else
			    mm++;
			}
			
			if(page==5)					//check day page
			{
			    if(dd==7)				//inc day
			    dd=1;
			    else
			    dd++;
			}
	    }

    
        if(!(S2_PIN&(1<<S2)))			//if Switch2 is pressed
        {
            _delay_ms(20);				//debounce
            while(!(S2_PIN&(1<<S2)));	//wait for release
            _delay_ms(20);				//debounce
			
			if(page<5)					//inc page
			page+=2;
			else						//time set start display
			{
			page+=2;
			clearram();
			break;
			}
        }
        
		if(page==1)						//hour page
		{
		    cursorxy(54,page);			//set cursor
            putstr("  ");				//blink
            _delay_ms(150);
			
		    cursorxy(54,page);			//set cursor
        
		    if(hh<10)					//if hour is less than 10
		    {
                putcharacter('0');
		        putcharacter('0'+hh);
		        _delay_ms(150);
		    }
        
		    else						//if hour is greater than 10
		    {
		        putcharacter('0'+(hh/10));
		        putcharacter('0'+(hh%10));
		        _delay_ms(150);
		    }
		}

        if(page==3)						//min page
		{
		    cursorxy(54,page);			//set cursor
            putstr("  ");				//blink
            _delay_ms(150);

            cursorxy(54,page);			//setcursor
        	
		    if(mm<10)					//if min is less than 10
		    {
                putcharacter('0');
		        putcharacter('0'+mm);
		        _delay_ms(150);
		    }
        
		    else						//if min is greater than 10
		    {
		        putcharacter('0'+(mm/10));
		        putcharacter('0'+(mm%10));
		        _delay_ms(150);
		    }
		}
        
        if(page==5)						//day page
		{
       	    cursorxy(54,page);			//setcursor
		    putstr("   ");				//blink
		    _delay_ms(150);
            cursorxy(54,page);
            if(dd==1)					//check dd value and set display day
		    putstr("Mon");
		    if(dd==2)
            putstr("Tue");
		    if(dd==3)
            putstr("Wed");
		    if(dd==4)
            putstr("Thu");
		    if(dd==5)
            putstr("Fri");
		    if(dd==6)
            putstr("Sat");
		    if(dd==7)
            putstr("Sun");
		    _delay_ms(150);
		}
    }

   
    boxes();      //displays outer boundry of the timeline display
    centerline(); //displays timeline
   
    s.start=678;  //initializes seconds to 0
    s.end=723;
    s.x=42;
    s.row=1;
   
    settime(mm,hh,dd);//set initial time
    check=0;
    s.row=1;
    m.row=3;
    h.row=5;
    d.row=5;
   
    extinit();    //external interrupt enable
    timer0init(); //timer start
    sei();        //Global interrupt enable
   
    while(1)
    {
        //start of code for seconds
        
		
        if(check==0)		//if seconds are to be displayed
		{   
            seconds();		//seconds calculated and displayed
			
			if(d.end!=127)	//count calculation of day as check is 0
            {
                if(d.c==19200)
                {
                    d.start+=1;        
	                d.end+=1; 
	                d.c=0;
                }        
            }

            else if(d.end==127)
            {
                if(d.c==19200)
                {
                    d.start+=1;
                    d.x+=1;
                    d.c=0;
                }
  
                if(d.x==83)
                {
                    d.end=85;
                    d.start=1;
                    d.x=0;
                }
            }
		}	
		
        minutes();		//minutes calulated and displayed
		
		hours();       //hours calculated and displayed
		
		//start of code for days
		if(check==1)
		{
		    days();			//days calculated and displayed
			
            if(s.end!=723)	//count calculation of seconds as check is 1
            {
                if(s.c==1)
                {
                    s.start+=3;        
	                s.end+=3; 
	                s.c=0;
                }         
            }

            else if(s.end==723)
            {
                if(s.c==1)
                {
                    s.start+=3;
                    s.x+=3;
                    s.c=0;
                }
  
                if(s.x==84)
                {
                    s.end=84;
                    s.start=0;
                    s.x=3;
                }
            }
		}//end of code for days
    }
}


ISR(TIMER0_OVF_vect)//timer interrupt service routine
{
    TCNT0L=(256-225);
    count++;

    if(count==8)//software prescaling by 8
    {
        count=0;

        if(s.c==0)//sec count
        s.c=1;
		
		if(m.c<20)//min count
        m.c++;
		
		if(h.c<1200)//hour count
		h.c++;
		
		if(d.c<19200)//day count
		d.c++;
    }
}

ISR(INT0_vect)//display sec on page 1 and get day off
{
    check=0;
    s.row=1;
    m.row=3;
    h.row=5;
    d.row=5;
}

ISR(INT1_vect)//display day on page 5 and get sec off
{
    check=1;
    s.row=1;
    m.row=1;
    h.row=3;
    d.row=5;
}
