/*

Chapter - 4
Project-19 Rise and Shine Bell
*/


#include<avr/io.h>
#define F_CPU 32768
#include <util/delay.h>
#include<avr/interrupt.h>
#include<avr/pgmspace.h>

//For LCD
#define SCK 2
#define SDIN 0
#define D_C  1
#define RESET 0

#define VCC 3

// For time
#define sec 0
#define min 1
#define hour 2

#define OCR1C_max 255
#define OCR1C_min 60

void RTC_init(void);
void setalarm(unsigned char data);
void showTime(unsigned char time[3],unsigned char x,unsigned char y);
void showTime_d(unsigned char x,unsigned char y);
void menu(void);
void menupoint(void);
void setmode(void);
void initalarm(void);
void stopalarm(void);
void initPLL(void);

volatile unsigned char Alarm[4][3]={	{20,20,20},
								{0,15,15},
								{0,10,10},
								{0,5,5}
						   };

volatile unsigned char al_play=0,al_on=0,minc=0,asd=0,update=0,current=0,alarm1=0,alarm2=0,alarm3=0,display=1;
volatile unsigned char timetext[6];


const char topic0[5]  ={"TIME"};
const char topic1[5]  ={"MODE"};
const char topic2[5]  ={"DISP"};
const char topic3[7]  ={"ALARM1"};
const char topic4[7]  ={"ALARM2"};
const char topic5[7]  ={"ALARM3"};





//LCD Prototypes
void initlcd(void);					// Initializes the LCD.
void writecom(char);				// Writes a command.
void writedata(char);				// Writes data to DDRAM to illuminate the pixels.
void clockdata(char);				// Clocks in data into the PCD8544 controller.
void clearram(void);				// Erase the DDRAM contents.
void cursorxy(char,char);			// Position cursor to x,y.
void putcharacter(char);			// Write one character.
void putcharacterinv(char);			// Write one character.
void putstr(const char *);			// Writes a string of characters.
void putstrinv(const char *);			// Writes a string of characters.
void putstrp(const char *s);
void putstrinvp(const char *s);


const char table[480] PROGMEM = {	0x00,0x00,0x00,0x00,0x00,	// 20 space		ASCII table for NOKIA LCD: 96 rows * 5 bytes= 480 bytes
							0x00,0x00,0x5f,0x00,0x00,	// 21 !			Note that this is the same set of codes for character you
							0x00,0x07,0x00,0x07,0x00,	// 22 "			would find on a HD44780 based character LCD. :)
							0x14,0x7f,0x14,0x7f,0x14,	// 23 #			Also, given the size of the LCD (84 pixels by 48 pixels),
							0x24,0x2a,0x7f,0x2a,0x12,	// 24 $			the maximum number of characters per row is only 14. :)
							0x23,0x13,0x08,0x64,0x62,	// 25 %
							0x36,0x49,0x55,0x22,0x50,	// 26 &
							0x00,0x05,0x03,0x00,0x00,	// 27 '
							0x00,0x1c,0x22,0x41,0x00,	// 28 (
							0x00,0x41,0x22,0x1c,0x00,	// 29 )
							0x14,0x08,0x3e,0x08,0x14,	// 2a *
							0x08,0x08,0x3e,0x08,0x08,	// 2b +
							0x00,0x50,0x30,0x00,0x00,	// 2c ,
							0x08,0x08,0x08,0x08,0x08,	// 2d -
							0x00,0x60,0x60,0x00,0x00,	// 2e .
							0x20,0x10,0x08,0x04,0x02,	// 2f /
							0x3e,0x51,0x49,0x45,0x3e,	// 30 0
							0x00,0x42,0x7f,0x40,0x00,	// 31 1
							0x42,0x61,0x51,0x49,0x46,	// 32 2
							0x21,0x41,0x45,0x4b,0x31,	// 33 3
							0x18,0x14,0x12,0x7f,0x10,	// 34 4
							0x27,0x45,0x45,0x45,0x39,	// 35 5
							0x3c,0x4a,0x49,0x49,0x30,	// 36 6
							0x01,0x71,0x09,0x05,0x03,	// 37 7
							0x36,0x49,0x49,0x49,0x36,	// 38 8
							0x06,0x49,0x49,0x29,0x1e,	// 39 9
							0x00,0x36,0x36,0x00,0x00,	// 3a :
							0x00,0x56,0x36,0x00,0x00,	// 3b ;
							0x08,0x14,0x22,0x41,0x00,	// 3c <
							0x14,0x14,0x14,0x14,0x14,	// 3d =
							0x00,0x41,0x22,0x14,0x08,	// 3e >
							0x02,0x01,0x51,0x09,0x06,	// 3f ?
							0x00,0x18,0x3C,0x7E,0xFF,	// 40 @
							0x7e,0x11,0x11,0x11,0x7e,	// 41 A
							0x7f,0x49,0x49,0x49,0x36,	// 42 B
							0x3e,0x41,0x41,0x41,0x22,	// 43 C
							0x7f,0x41,0x41,0x22,0x1c,	// 44 D
							0x7f,0x49,0x49,0x49,0x41,	// 45 E
							0x7f,0x09,0x09,0x09,0x01,	// 46 F
							0x3e,0x41,0x49,0x49,0x7a,	// 47 G
							0x7f,0x08,0x08,0x08,0x7f,	// 48 H
							0x00,0x41,0x7f,0x41,0x00,	// 49 I
							0x20,0x40,0x41,0x3f,0x01,	// 4a J
							0x7f,0x08,0x14,0x22,0x41,	// 4b K
							0x7f,0x40,0x40,0x40,0x40,	// 4c L
							0x7f,0x02,0x0c,0x02,0x7f,	// 4d M
							0x7f,0x04,0x08,0x10,0x7f,	// 4e N
							0x3e,0x41,0x41,0x41,0x3e,	// 4f O
							0x7f,0x09,0x09,0x09,0x06,	// 50 P
							0x3e,0x41,0x51,0x21,0x5e,	// 51 Q
							0x7f,0x09,0x19,0x29,0x46,	// 52 R
							0x46,0x49,0x49,0x49,0x31,	// 53 S
							0x01,0x01,0x7f,0x01,0x01,	// 54 T
							0x3f,0x40,0x40,0x40,0x3f,	// 55 U
							0x1f,0x20,0x40,0x20,0x1f,	// 56 V
							0x3f,0x40,0x38,0x40,0x3f,	// 57 W
							0x63,0x14,0x08,0x14,0x63,	// 58 X
							0x07,0x08,0x70,0x08,0x07,	// 59 Y
							0x61,0x51,0x49,0x45,0x43,	// 5a Z
							0x00,0x7f,0x41,0x41,0x00,	// 5b [
							0x02,0x04,0x08,0x10,0x20,	// 5c Yen Currency Sign
							0x00,0x41,0x41,0x7f,0x00,	// 5d ]
							0x04,0x02,0x01,0x02,0x04,	// 5e ^
							0x40,0x40,0x40,0x40,0x40,	// 5f _
							0x00,0x01,0x02,0x04,0x00,	// 60 `
							0x20,0x54,0x54,0x54,0x78,	// 61 a
							0x7f,0x48,0x44,0x44,0x38,	// 62 b
							0x38,0x44,0x44,0x44,0x20,	// 63 c
							0x38,0x44,0x44,0x48,0x7f,	// 64 d
							0x38,0x54,0x54,0x54,0x18,	// 65 e
							0x08,0x7e,0x09,0x01,0x02,	// 66 f
							0x0c,0x52,0x52,0x52,0x3e,	// 67 g
							0x7f,0x08,0x04,0x04,0x78,	// 68 h
							0x00,0x44,0x7d,0x40,0x00,	// 69 i
							0x20,0x40,0x44,0x3d,0x00,	// 6a j 
							0x7f,0x10,0x28,0x44,0x00,	// 6b k
							0x00,0x41,0x7f,0x40,0x00,	// 6c l
							0x7c,0x04,0x18,0x04,0x78,	// 6d m
							0x7c,0x08,0x04,0x04,0x78,	// 6e n
							0x38,0x44,0x44,0x44,0x38,	// 6f o
							0x7c,0x14,0x14,0x14,0x08,	// 70 p
							0x08,0x14,0x14,0x18,0x7c,	// 71 q
							0x7c,0x08,0x04,0x04,0x08,	// 72 r
							0x48,0x54,0x54,0x54,0x20,	// 73 s
							0x04,0x3f,0x44,0x40,0x20,	// 74 t
							0x3c,0x40,0x40,0x20,0x7c,	// 75 u
							0x1c,0x20,0x40,0x20,0x1c,	// 76 v
							0x3c,0x40,0x30,0x40,0x3c,	// 77 w
							0x44,0x28,0x10,0x28,0x44,	// 78 x
							0x0c,0x50,0x50,0x50,0x3c,	// 79 y
							0x44,0x64,0x54,0x4c,0x44,	// 7a z
							0x00,0x08,0x36,0x41,0x00,	// 7b <
							0x00,0x00,0x7f,0x00,0x00,	// 7c |
							0x00,0x41,0x36,0x08,0x00,	// 7d >
							0x10,0x08,0x08,0x10,0x08,	// 7e Right Arrow 	->
							0x78,0x46,0x41,0x46,0x78};	// 7f Left Arrow	<-


int main(void)
{
	
	
	DDRA &= ~(1<<4|1<<5|1<<6|1<<7);
	PORTA |= 1<<4|1<<5|1<<6|1<<7;//Pull ups
	
	DDRB |= 1<<3;//OC1B
	PORTB &= ~(1<<3);
	
	DDRB |= 1<<6;
	PORTB &= ~(1<<6);
	
	initlcd();
	RTC_init();
	initPLL();
	
	
	menu();
	menupoint();
	
		
	while(1)
	{	
		
		
		if((update==1)&&(display==1))
		{
			showTime_d(54,1);
			update = 0;
			
		}
		
		if(al_on==1)
		{
			OCR1C --;
			if(OCR1C<OCR1C_min)
			OCR1C = OCR1C_max;
			OCR1B = OCR1C/2;
		}
		
		if(al_play==1||al_play==2||al_play==3)
		{
			
			al_on=1;
			minc=0;
			if(display==1)
			{
				
				cursorxy(0,1);
				putstr("Alarm ");
				putcharacter(al_play+48);
			}
			initalarm();
			al_play=0;
		}

		
		if(!(PINA&(1<<4)))
		{
			
			while(!(PINA&(1<<4)));//wait
			
			if(display==0)
			{
				display = 1;
				initlcd();
				
				
			}
			else
			{
				if(current == 0)
				setalarm(0);
				else if(current==1)
				setmode();
				else if(current==2)
				{
					clearram();
					display =0;
					PORTA &= ~(1<<VCC);
				}
				else 
				setalarm(current-2);
			
				
			}
			//Required here because this block only clears the display
			if(display==1)
			{
				menu();
				menupoint();
			}
			
			
		}
		
		if(!(PINA&(1<<5)))
		{
		
			
			while(!(PINA&(1<<5)));//wait
			
			if(display==0)
			{
				display = 1;
				initlcd();
				menu();
			}
			else
			{
				
				current++;
				if(current==6)
				current=0;
			}
			menupoint();
		}
		
		if(!(PINA&(1<<6)))
		{
			
			while(!(PINA&(1<<6)));//wait
			
			if(display==0)
			{
				
				display = 1;
				initlcd();
				menu();
			}
			else
			{
				
				if(current==0)
				current = 5;
				else
				current--;
			}
			menupoint();
		}
		
		if(!(PINA&(1<<7)))
		{
			
			while(!(PINA&(1<<7)));//wait
			
			if(display == 0)
			{
				display = 1;
				menu();
				menupoint();
			}
			else if(al_on==1)
			{
		
				al_on=0;
				minc = 0;
				stopalarm();
			}
		}
		
		
			
		
	}


}


void initlcd(void)
{
	DDRA |= 1<<SCK|1<<D_C|1<<SDIN|1<<VCC;
	DDRB |= 1<<RESET;
	
	PORTA = PORTA|1<<VCC;
	
	PORTB = PORTB|1<<RESET;
	PORTB = PORTB&(~(1<<RESET));
	PORTB = PORTB|1<<RESET;
	writecom(0x21);		// Activate Chip and H=1.
	writecom(0xD3);		// Set LCD Voltage to about 9V.
	writecom(0x13);		// Adjust voltage bias.
	writecom(0x20);		// Horizontal addressing and H=0.
	writecom(0x09);		// Activate all segments.
	clearram();			// Erase all pixel on the DDRAM.
	writecom(0x08);		// Blank the Display.
	writecom(0x0C);		// Display Normal.
	cursorxy(0,5);
	putstr("              ");
	cursorxy(0,6);
	putstr("              ");
	cursorxy(0,0);		// Cursor Home.
	
}

void writecom(char command_in)
{
	PORTA = PORTA&(~(1<<D_C));				// Select Command register.
	clockdata(command_in);	// Clock in command bits.
	
}

void writedata(char data_in)
{
	PORTA = PORTA|(1<<D_C);//Select data register
	clockdata(data_in);		// Clock in data bits.
	
}

void clockdata(char bits_in)
{
	int bitcnt;
	for (bitcnt=8; bitcnt>0; bitcnt--)
		{
			PORTA = PORTA&(~(1<<SCK));								// Set Clock Idle level LOW.
			if ((bits_in&0x80)==0x80) {PORTA |=1<<SDIN;}	
			else {PORTA &= ~(1<<SDIN);}
			PORTA |=1<<SCK;								// Data is clocked on the rising edge of SCK.
			bits_in=bits_in<<1;						// Logical shift data by 1 bit left.
		}
}

void clearram(void)
{
	cursorxy(0,0);
	putstr("              ");
	cursorxy(0,1);
	putstr("              ");
	cursorxy(0,2);
	putstr("              ");
	cursorxy(0,3);
	putstr("              ");
	cursorxy(0,4);
	putstr("              ");
	cursorxy(0,5);
	putstr("              ");
	cursorxy(0,6);
	putstr("              ");
}

void cursorxy(char x, char y)
{
	writecom(0x40|(y&0x07));	// Y axis
	writecom(0x80|(x&0x7f));	// X axis
}

void putcharacter(char character)
{
	int tablept, count, char_column;

	if ((character<0x20)||(character>0x7f)) {return;}		// Exit function if character is not found.
	tablept = ((5*character) - 160);						// Point to the columns of the character in the table.

	for (count=5;count>0;count--)							// Draw the columns to print the character.
	{
		char_column = pgm_read_byte((table+tablept));
		writedata(char_column);
		tablept++;
	}
	writedata(0x00);										// 1 pixel spacing per character.
}

void putcharacterinv(char character)
{
	int tablept, count, char_column;

	if ((character<0x20)||(character>0x7f)) {return;}		// Exit function if character is not found.
	tablept = ((5*character) - 160);						// Point to the columns of the character in the table.

	for (count=5;count>0;count--)							// Draw the columns to print the character.
	{
		char_column = pgm_read_byte((table+tablept));
		writedata(~(char_column));
		tablept++;
	}
	writedata(0xff);										// 1 pixel spacing per character.
}

void putstr(const char *s)
{
	while(*s) {putcharacter(*s++);}					// Points to one ASCII to be written one at a time.
}

void putstrinv(const char *s)
{
	while(*s) {putcharacterinv(*s++);}					// Points to one ASCII to be written one at a time.
}

void putstrp(const char *s)
{
	while(*s) {putcharacter(pgm_read_byte(s++));}					// Points to one ASCII to be written one at a time.
}

void putstrinvp(const char *s)
{
	while(*s) {putcharacterinv(pgm_read_byte(s++));}					// Points to one ASCII to be written one at a time.
}



ISR(TIMER0_OVF_vect)
{
		asd++;
		if(asd==2)
		{
		 	update = 1;
			if(++Alarm[0][sec]==60)
			{
				Alarm[0][sec]=0;
				if(al_on==1)
				{
					minc++;
					if(minc==5)
					{
						
						al_on=0;
						minc = 0;
						stopalarm();
					}
				}
				if(++Alarm[0][min]==60)
				{
					Alarm[0][min]=0;
					if(++Alarm[0][hour]==24)
						Alarm[0][hour]=0;
				}
			
				if(al_on==0)
				{
					if((Alarm[0][hour]==Alarm[1][hour])&&(Alarm[0][min]==Alarm[1][min])&&(alarm1==1))
					{
						al_play=1;
					}
					else if((Alarm[0][hour]==Alarm[2][hour])&&(Alarm[0][min]==Alarm[2][min])&&(alarm2==1))
					{
						al_play=2;
					}
					else if((Alarm[0][hour]==Alarm[3][hour])&&(Alarm[0][min]==Alarm[3][min])&&(alarm3==1))
					{
				
						al_play=3;
					}
				}
				
				
			
			}
			
			
			asd = 0;
		}

	
}




void showTime(unsigned char Time[3],unsigned char x,unsigned char y)
{
     
    
	cursorxy(x%84,y%6);
	timetext[0]=(Time[hour]/10+'0');
	timetext[1]=(Time[hour]%10+'0');
	timetext[2]=(':');
	timetext[3]=(Time[min]/10+'0');
	timetext[4]=(Time[min]%10+'0');
	timetext[5]= '\0';
	putstr(timetext);
	
	
	
    	
}


void showTime_d(unsigned char x,unsigned char y)
{
     
    
	cursorxy(x%84,y%6);
	putcharacter(Alarm[0][hour]/10+'0');
	putcharacter(Alarm[0][hour]%10+'0');
	putcharacter(':');
	putcharacter(Alarm[0][min]/10+'0');
	putcharacter(Alarm[0][min]%10+'0');
	
	
	if(((Alarm[0][sec])%2))
	{
		cursorxy((x%84)+2*6,y%6);
		putcharacter(' ');
		/*
		cursorxy(x%84+6,y%6);
		putcharacter(' ');*/
	}

	if(al_on==0)
	{
		cursorxy(0,1);
		if(alarm1==1)
		{
			putstr("1 ");
		}
		else putstr("  ");
		if(alarm2==1)
		{
			putstr("2 ");
		}
		else putstr("  ");
		if(alarm3==1)
		{
			putstr("3  ");
		}
		else putstr("   ");
	}
	
    	
}

void setalarm(unsigned char data) //data should be 0,1,2,3
{
	
	clearram();
	unsigned char pos = 0;//should never be 2
	
	cursorxy(30,3);
	if(data==0)
	{
		putstr("Time");
	}
	else
	{
		putstr("Alarm");
		putcharacter(data+'0');
	}
    
	showTime(Alarm[data],30,5);
	
	cursorxy(30+pos*6,6);
	putcharacterinv(' ');
 	
	while(1)
	{
		if(update==1)
		{
			showTime_d(54,1);
			update = 0;
			
		}
		
		if(al_on==1)
		{
			OCR1C --;
			if(OCR1C<OCR1C_min)
			OCR1C = OCR1C_max;
			OCR1B = OCR1C/2;
		}
		
		if(al_play==1||al_play==2||al_play==3)
		{
			
			al_on=1;
			minc=0;
			if(display==1)
			{
				
				cursorxy(0,1);
				putstr("Alarm ");
				putcharacter(al_play+48);
			}
			initalarm();
			al_play=0;
		}
		
		if(!(PINA&(1<<4)))//Left
		{
			
			while(!(PINA&(1<<4)));//wait
			
			
			Alarm[data][hour] = (timetext[0]-'0')*10 + (timetext[1]-'0'); 
			Alarm[data][min] = (timetext[3]-'0')*10 + (timetext[4]-'0');
			
			clearram();
			break;
			
		}
		
		if(!(PINA&(1<<5)))//Right
		{
		
			
			while(!(PINA&(1<<5)));//wait
			
			cursorxy(30+pos*6,6);
			putcharacter(' ');
			if(pos==4)
			pos = 0;
			else if(pos==1)
			pos = 3;
			else
			pos++;
			cursorxy(30+pos*6,6);
			putcharacterinv(' ');
		}
		
		if(!(PINA&(1<<6)))//increment
		{
			
			while(!(PINA&(1<<6)));//wait
			
			if (pos==0 && timetext[1]>'3')
			{
				timetext[pos]= (timetext[pos]=='1') ? '0':timetext[pos]+1;
			}
			else if(pos==0)
			{
				 timetext[pos]= (timetext[pos]=='2') ? '0':timetext[pos]+1;
			}
			else if(pos==1 && timetext[0]=='2')
			{
				timetext[pos]= (timetext[pos]=='3') ? '0':timetext[pos]+1;

			}
			else if(pos==3)
			{
				timetext[pos]= (timetext[pos]=='5') ? '0':timetext[pos]+1;

			}
			else
				timetext[pos]= (timetext[pos]=='9') ? '0':timetext[pos]+1;
		
						
			cursorxy(30+pos*6,5);
			putcharacter(timetext[pos]);
			
		}
		
		if(!(PINA&(1<<7)))
		{
			
			while(!(PINA&(1<<7)));//wait
			
			
			
			if (pos==0 && timetext[1]>'3')
			{
				timetext[pos]= (timetext[pos]=='0') ? '1':timetext[pos]-1;
			}
			else if(pos==0)
			{
				 timetext[pos]= (timetext[pos]=='0' )? '2':timetext[pos]-1;
			}
			else if(pos==1 && timetext[0]=='2')
			{
				timetext[pos]= (timetext[pos]=='0') ? '3':timetext[pos]-1;

			}
			else if(pos==3)
			{
				timetext[pos]= (timetext[pos]=='0') ? '5':timetext[pos]-1;

			}
			else
				timetext[pos]= (timetext[pos]=='0') ? '9':timetext[pos]-1;
				
			
			
			cursorxy(30+pos*6,5);
			putcharacter(timetext[pos]);
		}
				

		
	}
		
}



void RTC_init(void)
{
    TCCR0B = 1<<CS00|1<<CS01;//By 64
	TIMSK = 1<<TOIE0;
	sei();

}

void menupoint(void)
{
	
	cursorxy(27,3);
	putcharacter(' ');
	cursorxy(27,4);
	putcharacter(' ');
	cursorxy(27,5);
	putcharacter(' ');
	cursorxy(75,3);
	putcharacter(' ');
	cursorxy(75,4);
	putcharacter(' ');
	cursorxy(75,5);
	putcharacter(' ');
	
	
	if(current<=2)
	{
		cursorxy(27,current+3);
		
	}
	else if(current>2)
	{
		cursorxy(75,current);
	}
	
	putcharacter('@');
	
	
	
}

void menu(void)
{

	
	
		
		cursorxy(0,3);
		putstr(topic0);
		cursorxy(0,4);
		putstr(topic1);	
		cursorxy(0,5);
		putstr(topic2);
	
	
	
		
		
		cursorxy(36,3);
		putstr(topic3);
		cursorxy(36,4);
		putstr(topic4);
		cursorxy(36,5);
		putstr(topic5);
		
		
	
}

void setmode(void)
{
	
	clearram();
	
	cursorxy(0,2);
	putstr("Alarm1");
	cursorxy(48,2);
	if(alarm1 == 1)
	putstr(" ON");
	else
	putstr("OFF");
	
	cursorxy(0,3);
	putstr("Alarm2");
	cursorxy(48,3);
	if(alarm2 == 1)
	putstr(" ON");
	else
	putstr("OFF");
	
	cursorxy(0,4);
	putstr("Alarm3");
	cursorxy(48,4);
	if(alarm3 == 1)
	putstr(" ON");
	else
	putstr("OFF");
	
	cursorxy(0,5);
	putstr("Exit");
	
	while(1)
	{
		if((update==1)&&(display==1))
		{
			showTime_d(54,1);
			update = 0;
			
		}
		
		if(al_on==1)
		{
			OCR1C --;
			if(OCR1C<OCR1C_min)
			OCR1C = OCR1C_max;
			OCR1B = OCR1C/2;
		}
		
		if(al_play==1||al_play==2||al_play==3)
		{
			
			al_on=1;
			minc=0;
			if(display==1)
			{
				
				cursorxy(0,1);
				putstr("Alarm ");
				putcharacter(al_play+48);
			}
			initalarm();
			al_play=0;
		}
			
		if(!(PINA&(1<<4)))//Left
		{
			
			while(!(PINA&(1<<4)));//wait
			
			
			alarm1 = (alarm1==1)?0:1;
			
			cursorxy(48,2);
			if(alarm1 == 1)
			putstr(" ON");
			else
			putstr("OFF");
			
			
		}
		
		if(!(PINA&(1<<5)))//Right
		{
		
			
			while(!(PINA&(1<<5)));//wait
			
			alarm2 = (alarm2==1)?0:1;
			
			cursorxy(48,3);
			if(alarm2 == 1)
			putstr(" ON");
			else
			putstr("OFF");
		}
		
		if(!(PINA&(1<<6)))//increment
		{
			
			while(!(PINA&(1<<6)));//wait
			
			alarm3 = (alarm3==1)?0:1;
			
			cursorxy(48,4);
			if(alarm3 == 1)
			putstr(" ON");
			else
			putstr("OFF");
			
			
			
		}
		
		if(!(PINA&(1<<7)))
		{
			
			while(!(PINA&(1<<7)));//wait
			
			
			clearram();
			break;
			
		}
	}
}

void initPLL(void)
{
	PLLCSR = 1<<PLLE;
	while(!(PLLCSR&(1<<PLOCK)));
	PLLCSR |= 1<<PCKE;
}

void initalarm(void)
{
	
	//Fast PWM //Non Inverting
	TCCR1A = 1<<COM1B1|1<<PWM1B;
	TCCR1B = 1<<CS13|0<<CS12|1<<CS11|1<<CS10;
	TCCR1C = 1<<COM1B1S;
	TCCR1D = 0<<WGM11|0<<WGM10;
	PORTB |= 1<<6;
	OCR1C = 255;//8 bit resolution
	OCR1B = OCR1C/2;
	
}


void stopalarm(void)
{
	
	
	PORTB &= ~(1<<3);
	PORTB &= ~(1<<6);
	TCCR1A = 0<<COM1B1|0<<PWM1B;
	TCCR1B = 0<<CS13|0<<CS12|0<<CS11|0<<CS10;
	TCCR1C = 0<<COM1B1S;
	TCCR1D = 0<<WGM11|0<<WGM10;
	OCR1C = 0;
	OCR1B = 0;
	
	
}
