/*
Chapter-5
Project 21 Valentine’s Heart LED Display with Proximity Sensor
*/

#include<avr/io.h>
#define F_CPU 9600000UL
#include<avr/interrupt.h>

#define NONE 0
#define NORMAL 1
#define HAPPY 2
//Hardware description 

//Display
//PINB0 outer heart	   statusonoff[0] 
//PINB1 middle heart   statusonoff[1]
//PINB2 inner heart    statusonoff[2]

//Sensing 
//PINB4 anode 
//PINB3 cathode

//statusonoff = {0 1 2 3 4 5 6 7 8 9}
             // ON                OFF   

//mode = 4 is the default mode

//Global variables
volatile unsigned char mode=NORMAL,previous_mode=NONE;
volatile unsigned char i=0;
volatile unsigned char state=1,a=20;
volatile unsigned char ambient=0;
volatile unsigned char time=0;



//Prototypes
void check(void);
void mydelay(int var);

//main starts
int main(void)
{
	
	//TIMER INITIALISATION
	TCCR0A = 0;
	TCCR0B = 1<<CS00|1<<CS02;//Prescaled by 1024
	
	
	//PORT INITIALISATION
	DDRB = 0b00011111;
	PORTB =0b00001000; //PB4 always low
    mydelay(100);
	check();
	while(1)
	{
	
		if(mode==NORMAL)
		{
			PORTB &=0b11111000;//off
			mydelay(a+a+a+a);
			PORTB |=0b00000111;//on
			mydelay(a+a);
			PORTB &=0b11111000;//off
			mydelay(a+a);
			PORTB |=0b00000111;//on
			mydelay(a+a);
			time=0;
			 
		}
		else if(mode==HAPPY)
		{
			
		
			if(state==1)
			PORTB |=1<<2;
			else if(state==5)
			PORTB &= ~(1<<2);
			
			if(state==5)
			PORTB &=~(1<<1);//Middle off
			else if(state==2)
			PORTB |=1<<1;//Middle on
			
			
			if(state==4)
			PORTB &=~(1<<0);//Outer off
			else if(state==3)
			PORTB |=1<<0;//Outer on
			
			
			mydelay(5*state);
			
			state++;
			if(state==6)
			state=1;
			
			time++;
			if(time==100) //Change from happy mode to normal
			{
				mode = NORMAL;
				previous_mode = NONE;
				time=0;
				a=20;
				
			}
		}
		check();
	   
	
	}
	
   


}
//main ends



void check(void)
{
	
	
	TCCR0B = 0;//stop timer
	TCNT0 = 0;//clear timer
	i=0;
	DDRB = 0b00010000;
	PORTB &= ~(1<<3);
    i=0;
	TCCR0B = 1<<CS02|1<<CS00;//Prescaled by 1024
	while((PINB&(1<<3))&&(i<80))
	{
		i=TCNT0;
	}
	
	if(i>50) //Object is faraway
	{
		if((previous_mode==NORMAL))// Object was previoulsy nearby
		{
			mode = HAPPY;
		}
		else a=20;
	}
	else if(i<50) //Object is nearby
	{
		if(i<40)
		{
			previous_mode = NORMAL;
		}
		else previous_mode = NONE;
		mode = NORMAL;
		a=i/3;

	}
	
	
	PORTB |=1<<3;
	DDRB = 0b00011111;
	
	
}

void mydelay(int var)		//delay of 10ms for var=1 at 9.6 MHZ
{

	unsigned char il, jl, kl;

	for (il=0; il<var; il++) 
	for (jl=0; jl<251;jl++)
	for (kl=0; kl<50; kl++) 
	asm("NOP");

}