#ifndef LCD_H
#define LCD_H



#define LCD_PORT PORTA
#define LCD_DDR  DDRA
#define RST_PORT PORTB
#define RST_DDR  DDRB



#define SCK   7
#define SDIN  6
#define D_C   5
#define RESET 3

extern const char table[];

//LCD Prototypes
void initlcd(void);					// Initializes the LCD.
void writecom(char);				// Writes a command.
void writedata(char);				// Writes data to DDRAM to illuminate the pixels.
void clockdata(char);				// Clocks in data into the PCD8544 controller.
void clearram(void);				// Erase the DDRAM contents.
void cursorxy(char,char);			// Position cursor to x,y.
void putcharacter(char);			// Write one character.
void putcharacterinv(char);			// Write one character(inverted)
void putstr(const char *);			// Writes a string of characters
void putstrinv(const char *);		// Writes a string of characters(inverted)

#endif
