/*
CHAPTER - 5 
Project 25 - Inductive loop based Car detector and counter
*/

#include<avr/io.h>
#include"lcd.h"
#include<avr/interrupt.h>
#include"detector.h"



int main(void)

{
	//Setting up 
	
	SWITCH_DDR  &= ~(1<<SWITCH_1);										//Declare as input
	SWITCH_PORT |=  (1<<SWITCH_1);										//pulled high

	initlcd();															//Initializing LCD
	TCCR1A |=  (1<<COM1A1);
	TCCR1B |= ((1<<CS13) | (1<<CS12) | (1<<CS11) | (1<<CS10));   //with prescaler of 16384, WGM for CTC mode	OCR1A = 31250;        	//for 1sec interrupt
	TCCR1D &= ~((1<<WGM11) | (1<<WGM10));
	OCR1A = 254; 
	TIMSK |= (1<<OCIE1A);   	//enable compare interrupt 
	sei();					//Enable global interrupt
	
	
	display_car(car_counter);											//display the number of cars
	select_case = s0;													//select the case for setting base_freq
	for( ; ;)
	{
		switch(select_case)
		{
			case s0 :
					{
						
						if( !(SWITCH_PIN&(1<<2)) ) 					//When switch Pressed
						{
							//while(!(PIND&(1<<2)));
							base_freq = changing_freq; 					//Set the Base frequency
							display_base_freq(base_freq);				//display it on LCD
							select_case = s1;							//Case s1 selected
						}
						
						break;

					 }
			
			case s1 : 
					{	
						
						while( changing_freq > (base_freq+upper_threshold_freq) )		//If changing Frequency Crosses threshold
						{
							select_case = s2;											//Case s2 selected
							break;
						}
					 	
						if(!(SWITCH_PIN&(1<<2))) 										//When switch Pressed
						{
								while(!(PINA&(1<<2)));
								select_case = s0;										//case s0 selected
						}
							
						break;
					
					}							
			
			case s2 :
					{	
						
						while( changing_freq < (base_freq+lower_threshold_freq) )		//If changing Frequency back to normal
						{
							car_counter = car_counter+1;								//Car counter incremented
							display_car(car_counter);									//Display number of cars
							select_case = s1;											//Case s1 selected
							break;
						}

						break;
					
					}
			
		}			

	}

}




ISR(TIMER1_COMPA_vect)  	//Setting up interrupt service routine for Compare mode
{
	
	//Counts no. of pulses for .1 sec
	
	ovf_counter = 0;
	
	TCCR0B = ((1<<CS02) | (1<<CS01) | (1<<CS00));   //enable Normal mode, External Clk T0 rising trigger
	//TCNT0 is increases for every rising edge
	
	TCNT1=0;
	TCNT0L=0;
	
	while((45)>=(uint32_t)TCNT1) 
	{
		

		if(TCNT0L==255)
		{
			ovf_counter += 1;
			TCNT0L=0;
		}
		
		
		counts = TCNT0L;
		
	}
		
		//Total count after .1 sec 
		//Calculations for finding current frequency
		
		counts = (ovf_counter * 255) + counts;
		freq=(float)counts;
		freq=freq*10;
		counts=(uint32_t)freq;
		counts=counts/10;
		changing_freq = counts;
		
		LCD_partclear();
		display_changing_freq();
}

void display_changing_freq(void)		//Displays the current frequency
{
	unsigned char t;
	t = counts/10000;
		
		if(j==5)
		{
			j=1;
			if(i==48)
				i=6;
			else 
				i=48;
		}

         cursorxy(i-6,j);
		 putstr(">");
		{
			cursorxy(0+i,j);
			putcharacter(t+48);//Digit to ASCII
		  
		}	
		
		counts = counts%10000;
		
		{	
			cursorxy(6+i,j);
			t = counts/1000;
			putcharacter(t+48);//Digit to ASCII
		}
		
		
		
		counts = counts%1000;
		
		{	
			cursorxy(12+i,j);
			t = counts/100;
			putcharacter(t+48);//Digit to ASCII
		    putcharacter('.');
		}
		
		
		counts = counts%100;
		
		{	
			cursorxy(24+i,j);
			t = counts/10;
			putcharacter(t+48);//Digit to ASCII
		}
		
		counts = counts%10;
		
		{	
			cursorxy(30+i,j);
			t = counts;
			putcharacter(t+48);//Digit to ASCII
		}
         j++;
}



void display_base_freq(uint32_t var)		//Displays the Base frequency
{
		unsigned char t;
		t = var/10000;
		 cursorxy(0,6);
		 putstr("FB");
		 cursorxy(12,6);
		 putstr("=");
		{
			cursorxy(18,6);
			putcharacter(t+48);//Digit to ASCII
		  
		}	
		
		var = var%10000;
		
		{	
			cursorxy(24,6);
			t = var/1000;
			putcharacter(t+48);//Digit to ASCII
		}
		
		
		
		var = var%1000;
		
		{	
			cursorxy(30,6);
			t = var/100;
			putcharacter(t+48);//Digit to ASCII
		    putcharacter('.');
		}
		
		
		var = var%100;
		
		{	
			cursorxy(42,6);
			t = var/10;
			putcharacter(t+48);//Digit to ASCII
		}
		
		var = var%10;
		
		{	
			cursorxy(48,6);
			t = var;
			putcharacter(t+48);//Digit to ASCII
		}
         
		cursorxy(56,6);
		putstr(" k");//Digit to ASC		

}

void display_car(int var1)			//Dislays the Number of cars
{
		unsigned char t;
		t = var1/10000;
		 cursorxy(0,5);
		 putstr("CARS");
		 cursorxy(27,5);
		 putstr("=");
		{
			cursorxy(33,5);
			putcharacter(t+48);//Digit to ASCII
		  
		}	
		
		var1 = var1%10000;
		
		{	
			cursorxy(39,5);
			t = var1/1000;
			putcharacter(t+48);//Digit to ASCII
		}
		
		
		
		var1 = var1%1000;
		
		{	
			cursorxy(45,5);
			t = var1/100;
			putcharacter(t+48);//Digit to ASCII
		}
		
		
		var1 = var1%100;
		
		{	
			cursorxy(51,5);
			t = var1/10;
			putcharacter(t+48);//Digit to ASCII
		}
		
		var1 = var1%10;
		
		{	
			cursorxy(57,5);
			t = var1;
			putcharacter(t+48);//Digit to ASCII
		}
}         
	

void LCD_partclear(void)
{
  int u,v;
  cursorxy(i-6,j-1); //starting with (0,0)
  for(v=j-1;v<j;v++)
   {
     for(u=i-6;u<i;u++)
	  {
	    cursorxy(u,v);
	    writedata(0x00);
      }
   }
   cursorxy(0,0);
}

