/*

Chapter -  5 
Project - 26 Electronic Birthday Blowout Candles

*/

//Hardware Description
/*           Enable         Cathode              Variable
Led 1        PB0         	 PA2                     0 
Led 2        PB0             PA3                     1
Led 3        PB0             PA4                     2  
Led 4        PB0             PA5                     3
Led 5        PB0             PA6                     4
Led 6        PB1             PA2					 5
Led 7        PB1             PA3					 6
Led 8        PB1             PA4
Led 9        PB1             PA5
Led 10       PB1             PA6
Led 11       PB2             PA2
Led 12       PB2             PA3                     11
Led 13		 PB2			 PA4
Led 14		 PB2             PA5
Led 15       PB2             PA6
Led 16	     PA0			 PA2					 15
Led 17       PA0             PA3
Led 18       PA0             PA4
Led 19       PA0             PA5
Led 20		 PA0             PA6					 19

ADC7 used


*/


#include<avr/io.h>
#include<avr/interrupt.h>
#define F_CPU 8000000UL
#include<util/delay.h>



//Prototypes
void setrandom(void);
void abc(unsigned char a,unsigned char b,unsigned char c,unsigned char d,unsigned char e,unsigned char status);
void xyz(void);


void delay(int var)		//delay of 10ms for var=1
{

	unsigned char il, jl, kl;

	for (il=0; il<var; il++) 
	for (jl=0; jl<32;jl++)
	for (kl=0; kl<249; kl++) 
	asm("NOP");
}
		 
volatile unsigned char statusonoff[20] ={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
volatile unsigned char e,e1,e2,e3,enable;//Multiplexing
volatile unsigned char pwm[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//PWM scale 0 - On 4 OFF
volatile unsigned int a=0;//ADC
volatile unsigned char z=0;//Random Number Generator
volatile unsigned char ab=0;//Random Counter
volatile int present=4500,past=4500,q=0;//ADC
volatile unsigned long qw=0;//ADC
volatile unsigned char z1[8]={9,9,9,9,9,9,9,9};//Random Number Generator
volatile unsigned char column=0;

int main(void)
{

    //ADC Initialisation
	ADMUX=0b00000111;			//VCC 5V used as Voltage Reference,analog i/p at PA7(ADC 7)
	ADCSRA=0b11101111;		                                        	//ADC Enable,ADC Start Conversion,division factor 128,Auto trigger enable
	ADCSRB = 1<<ADLAR;	//ADC Free Running mode
	
	sei();//Global Interrupts Enabled
	
	
	//Timer Initialisation
	TCCR0A = 0x00;//No PWM
	TCCR0B = 0x02;//Prescaling
	TIMSK0 = 1<<TOIE0;//Overflow Interrupt Enabled

	DDRB = 0x0f;
	DDRA = 0x7f;//PA7 is ADC Input
	PORTB = 0x0f;
	PORTA = 0x7f;

	
	while(1)
	{
		
	
		
		z++;
		if(z==8)
		z=0;
		
		//generate a random number from 1 to 8 which has not beeen generated before
		while(1)
		{
			if(z1[z]==z)
			{
				z++;
				if(z==8)
				z=0;
			}
			else 
			break;
		}
		
		if((present-past)>=3)
		{
			if(z==0)
			{
				statusonoff[0] = 0;
				statusonoff[5] = 0;
				statusonoff[9] = 0;
				statusonoff[12]=0;
				z1[0] = 0;
			}
			else if(z==1)
			{
				statusonoff[2] = 0;
				statusonoff[6] = 0;
				z1[1] = 1;
				
			}
			else if(z==2)
			{
				statusonoff[1] = 0;
				statusonoff[7] = 0;
				statusonoff[14]=0;
				z1[2] = 2;
			}
			else if(z==3)
			{
				statusonoff[11] = 0;
				z1[3] = 3;
				
			}
			else if(z==4)
			{
				statusonoff[15] = 0;
				statusonoff[18] = 0;
				z1[4] = 4;
				
			}
			else if(z==5)
			{
				statusonoff[10] = 0;
				statusonoff[13] = 0;
				z1[5] = 5;
				
			}
			else if(z==6)
			{
				statusonoff[3] = 0;
				statusonoff[4] = 0;
				statusonoff[8] = 0;
				z1[6] = 6;
				
			}
			else if(z==7)
			{
				statusonoff[17] = 0;
				statusonoff[16] = 0;
				statusonoff[19]=0;
				z1[7] = 7;
			}

		}
		
		else
		setrandom();
	
		delay(10);
			


	}

	return 0;

}

void setrandom(void)
{
	if(ab==0)
	{
		pwm[0]=3;pwm[1]=0;pwm[2]=0;pwm[3]=0;
		pwm[4]=0;pwm[5]=0;pwm[6]=2;pwm[7]=3;
		pwm[8]=3;pwm[9]=1;pwm[10]=1;pwm[11]=3;
		pwm[12]=3;pwm[13]=1;pwm[14]=1;pwm[15]=0;
		pwm[16]=3;pwm[17]=2;pwm[18]=4;pwm[19]=0;
	}
	if(ab==1)
	{
		pwm[0]=1;pwm[1]=1;pwm[2]=1;pwm[3]=1;
		pwm[4]=1;pwm[5]=3;pwm[6]=1;pwm[7]=2;
		pwm[8]=2;pwm[9]=3;pwm[10]=0;pwm[11]=2;
		pwm[12]=2;pwm[13]=1;pwm[14]=3;pwm[15]=1;
		pwm[16]=2;pwm[17]=1;pwm[18]=1;pwm[19]=1;
	}
	if(ab==2)
	{
		pwm[0]=2;pwm[1]=2;pwm[2]=2;pwm[3]=3;
		pwm[4]=2;pwm[5]=2;pwm[6]=0;pwm[7]=0;
		pwm[8]=1;pwm[9]=0;pwm[10]=1;pwm[11]=3;
		pwm[12]=3;pwm[13]=1;pwm[14]=0;pwm[15]=3;
		pwm[16]=1;pwm[17]=3;pwm[18]=2;pwm[19]=2;
	}
	if(ab==3)
	{
		pwm[0]=0;pwm[1]=3;pwm[2]=3;pwm[3]=2;
		pwm[4]=3;pwm[5]=1;pwm[6]=3;pwm[7]=1;
		pwm[8]=0;pwm[9]=2;pwm[10]=2;pwm[11]=0;
		pwm[12]=1;pwm[13]=1;pwm[14]=2;pwm[15]=2;
		pwm[16]=0;pwm[17]=0;pwm[18]=3;pwm[19]=3;
	}
	ab++;
	if(ab==4)
	ab=0;
}


ISR(TIM0_OVF_vect)
{
	DDRB = 0;
	DDRA = 0;
	PORTB |=1<<0;
	PORTB |=1<<1;
	PORTB |=1<<2;
	PORTA |=1<<0;
	if(enable>=0&&enable<=3)
	{
		PORTB |=1<<0;
	    PORTB |=1<<1;
	    PORTB |=1<<2;
	    PORTA |=1<<0;
		if(e==4)
		{
			e=0;
			xyz();
		}
		column=0;
		abc(pwm[0],pwm[1],pwm[2],pwm[3],pwm[4],e);
		PORTB &=~(1<<0);
		e++;
	}
	else if(enable>=4&&enable<=7)
	{
		PORTB |=1<<0;
	    PORTB |=1<<1;
	    PORTB |=1<<2;
	    PORTA |=1<<0;
		if(e1==4)
		{
			e1=0;
			xyz();
		}
		column=5;
		abc(pwm[5],pwm[6],pwm[7],pwm[8],pwm[9],e1);
		PORTB &=~(1<<1);
		e1++;
	}
	else if(enable>=8&&enable<=11)
	{
		PORTB |=1<<0;
		PORTB |=1<<1;
		PORTB |=1<<2;
		PORTA |=1<<0;
		if(e2==4)
		{
			e2=0;
			xyz();
		}
		column=10;
		abc(pwm[10],pwm[11],pwm[12],pwm[13],pwm[14],e2);
		PORTB &=~(1<<2);
		e2++;
	}
	else if(enable>=12&&enable<=15)
	{
		PORTB |=1<<0;
		PORTB |=1<<1;
		PORTB |=1<<2;
		PORTA |=1<<0;
		if(e3==4)
		{
			e3=0;
			xyz();
		}
		column=15;
		abc(pwm[15],pwm[16],pwm[17],pwm[18],pwm[19],e3);
		PORTA &=~(1<<0);
		e3++;
	}
	enable++;
	if(enable==16)
	enable=0;
	
	DDRB = 0x0f;
	DDRA = 0x7f;
	
}

void xyz(void)
{
	
	PORTA |= 1<<2;
	PORTA |= 1<<3;
	PORTA |= 1<<4;
	PORTA |= 1<<5;
	PORTA |= 1<<6;
	
	
}


void abc(unsigned char a,unsigned char b,unsigned char c,unsigned char d,unsigned char e,unsigned char status)
{

	if((status==a)&&((statusonoff[column+0]==1)))
	{
		PORTA = PORTA&~(0b01000000);
	}
	if((status==b)&&((statusonoff[column+1]==1)))
	{
		PORTA = PORTA&~(0b00100000);
	}
	if((status==c)&&((statusonoff[column+2]==1)))
	{
		PORTA = PORTA&~(0b00010000);
	}
	if((status==d)&&((statusonoff[column+3]==1)))
	{
		PORTA = PORTA&~(0b00001000);
	}
	if((status==e)&&((statusonoff[column+4]==1)))
	{
		PORTA = PORTA&~(0b00000100);
	}
	
}


ISR(ADC_vect)
{

		
        a=ADCH;
		float out;
		int as;
		out = (a*4)*5/(1024.0);
		as = out*1000;
		qw +=as;
		q++;
		if(q==1000)
		{
			past = present;
			qw = qw/1000;
			present = qw;
			q=0;qw=0;
		}
			
}
