


/*
CHAPTER - 5 
Project 27 - Fridge Alarm
*/

#include<avr/io.h>
#define F_CPU 1200000UL
#include<util/delay.h>
#include<avr/sleep.h>
#include<avr/interrupt.h>

#define powerdown MCUCR=((1<<SE)|(1<<SM1))
void all_off(void);              
void speaker_init(void);
void timer_init(void);
void pcint_init(void);

volatile unsigned char c,a,d;

int main(void)
{
DDRB|=(1<<PB4)|(1<<PB1);//inputs
DDRB &=~(1<<PB0);//output
PORTB|=(1<<PB4);//led off
pcint_init();//initiate pc interrupt
sei();


while(1)
{

if(d==1)//door on after 9 secs
{
d=0;
speaker_init();//speaker initiate
TIMSK0 &=~(1<<TOIE0);//timer overflow off
}

if(a==1)
{
OCR0A=0x02;//frequency 1
PORTB&=~(1<<PB4);//led on
_delay_ms(200);
OCR0A=0x05;//frequency 2
PORTB|=(1<<PB4);// led off
_delay_ms(200);
}

}

}

void timer_init(void)//initiate timer overflow
{
TCCR0B |=(1<<CS00)|(1<<CS02);
TIMSK0 |=1<<TOIE0;
}

void speaker_init(void)//initiate speaker
{
DDRB|=(1<<PB1);
OCR0A=0x01;
TCCR0B|=(1<<CS01|1<<CS00);
TCCR0B&=~(1<<CS02);
TCCR0A|=((1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00));
TCCR0B|=(1<<WGM02);
}

void all_off(void)//all i/o off
{
DDRB&=~(1<<PB0|1<<PB4);
DDRB|=(1<<PB1);
PORTB&=~(1<<PB4|1<<PB1);
TIMSK0 &=~(1<<TOIE0);
OCR0A=0x00;
TCCR0B&=~((1<<CS00)|(1<<CS02)|(1<<CS01));
TCCR0A&=~((1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00));
TCCR0B&=~((1<<WGM02));
}

void pcint_init(void)//initialise pin change interrupt
{
GIMSK=(1<<PCIE);
PCMSK=(1<<PCINT0);
}


ISR(TIM0_OVF_vect)//timer interrupt routine 
{
c++;//increment c
if(c==49)//call after 9 sec(approx)
{
c=0;
a=1;
d=1;
}
}

ISR(PCINT0_vect)//pc_int routine
{
pcint_init();     //enabling interrupt
sei();            //setting enable bit as 1
if(!(PINB&(1)))   //if PINB is 0, then a=1
{
a=0;//initial condition
TCNT0=0X00;//initialise timer
timer_init();
sei();//set interrupt enable
DDRB|=(1<<PB4);//led on
PORTB&=~(1<<PB4);
}
else if((PINB&(1))==1)
{
a=0;//initial condition
c=0;
d=0;
all_off();//all i/o off 
powerdown;//go to power down
sleep_cpu();
}
}


