/*
CHAPTER - 6
Project 28 - Tone Player
*/


//Tiny 45 code
#include<avr/io.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include<avr/pgmspace.h>
#include<avr/interrupt.h>



struct _Note 
{
    int frequency;
    int durationMS;

};
void play_tone_P(struct _Note *);
struct _Note song1[] PROGMEM = {				
{ 360, 784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1048},{ 960, 494}, 
{ 360,	784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1176},{ 960, 1048},{ 360, 784},
{ 120, 784},{ 480, 1568},{ 480, 1320},{ 480, 1048},{ 480, 494},{ 480, 440},{ 240,1396},
{ 480, 0},{ 120, 1396},{ 480, 1320},{ 480, 1048},{ 480, 1176},{ 960, 1048 },{0,0}
}; 


struct _Note song2[] PROGMEM = {				
{ 360, 784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1048},{ 960, 494}, 
{ 360,	784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1176},{ 960, 1048},{ 360, 784},
{ 120, 784},{ 480, 1568},{ 480, 1320},{ 480, 1048},{ 480, 494},{ 480, 440},{ 240,1396},
{ 480, 0},{ 120, 1396},{ 480, 1320},{ 480, 1048},{ 480, 1176},{ 960, 1048 },{0,0}
}; 


struct _Note song3[] PROGMEM = {				
{ 360, 784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1048},{ 960, 494}, 
{ 360,	784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1176},{ 960, 1048},{ 360, 784},
{ 120, 784},{ 480, 1568},{ 480, 1320},{ 480, 1048},{ 480, 494},{ 480, 440},{ 240,1396},
{ 480, 0},{ 120, 1396},{ 480, 1320},{ 480, 1048},{ 480, 1176},{ 960, 1048 },{0,0}
}; 

struct _Note song4[] PROGMEM = {				
{ 360, 784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1048},{ 960, 494}, 
{ 360,	784},{ 120, 784},{ 480, 440},{ 480, 784},{ 480, 1176},{ 960, 1048},{ 360, 784},
{ 120, 784},{ 480, 1568},{ 480, 1320},{ 480, 1048},{ 480, 494},{ 480, 440},{ 240,1396},
{ 480, 0},{ 120, 1396},{ 480, 1320},{ 480, 1048},{ 480, 1176},{ 960, 1048 },{0,0}
}; 


		

unsigned int ch = 000;

ISR(PCINT0_vect)
{   
	_delay_ms(10);	//debounce
		
	
   if(! (PINB & (1 << PB2)) )   // Switch 1 high
    	ch |= 001;

   else
		ch &= 110;
   
   if ( ! (PINB & (1 << PB3)) )  // Switch 2 high
   		ch |= 010;

   else
		ch &= 101;

   if ( ! (PINB & (1 << PB4)) )  // Switch 3 pressed 
   		ch |= 100;
   	
   else
		ch &= 011;

}

int main(void)
{
	DDRB &= ~((1<<PB2)|(1<<PB3)|(1<<PB4));//Input declared
	PORTB |= ((1<<PB2)|(1<<PB3)|(1<<PB4));//Pull up Enabled
	DDRB  |= (1<<PB1);//output declared
	PORTB |= (1<<PB1);//Pull up Enabled
	GIMSK |= (1<<PCIE);//PCINT4 general interrupt enable
	PCMSK |= ((1<<PCINT2)|(1<<PCINT3)|(1<<PCINT4));//PCINT4 interrupt enable

	sei();
  	
	//song:
	
	while(1)

	{	
		switch(ch)
		{
			case 000:
				play_tone_P(song1);
				break;
			case 001:
				play_tone_P(song2);
				break;
			case 010:
				play_tone_P(song3);
				break;
			case 011:
				play_tone_P(song4);
				break;
		}
	}
}

void play_tone_P(struct _Note *p)
{
	int duration, note, top ;
	
	while(pgm_read_word(p))
	{
		note = pgm_read_word(p);
		p++;
		duration = pgm_read_word(p);
		p++;

		top = (int)(31250/note);
		DDRB |= ((1<<PB0)|(1<<PB1));
		TCCR0B |= ((1<<CS02)|(1<<CS00));	//1024 prescalar
		TCCR0B &= ~(1<<WGM02);		//Normal Mode
		TCCR0A &= ~((1<<WGM00) | (1<<WGM01));	

		//Playing tone
		if(note)
		{

			TCCR1 |= ((1<<PWM1A) | (1<<COM1A0) | (1<<CS13) | (1<<CS10));
			//256 prescalar, pwm mode on
			OCR1C = top;					//Top value 
			OCR1A = (OCR1C>>1);				//Duty Cycle
			TCNT0 = 0;

			for(;;)
			{
				if(!(PINB&(1<<PB4)))
				{
					
					return;
				}
		
				if(TCNT0 >= 78)
				{
					duration = duration - 10;
					TCNT0 = 0;
				}
				
				if(duration <= 0)
					break;	
			}

			TCCR0B = 0x00;
		}

	 	else
	 	{
			TCNT0 = 0;
	
			for(;;)
			{
				if(!(PINB&(1<<PB4)))
					{
						
						return;
					}
		
				if(TCNT0 >= 78)
					{
						duration = duration - 10;
						TCNT0 = 0;
					}
				
				if(duration <= 0)
					break;
			}
		TCCR0B = 0x00;
		}	


	}

}
