/*
cHAPTER - 2 
Project 2 - Flickering Candle
*/

/*
Code for a flickering candle project
Connect a 1-W Yellow/Warm White LED on
Pin 2 - PB3 <-- 100Ohm R --> LED Cathode
Pin 3 - PB4 <-- 100Ohm R --> LED Cathode
Pin 5 - PB0 <-- 100Ohm R --> LED Cathode
Pin 5 - PB0 <-- 100Ohm R --> LED Cathode
Pin 6 - PB1 <-- 100Ohm R --> LED Cathode
Pin 7 - PB2 <-- 100Ohm R --> LED Cathode
LED Anode to Vcc
Set max current to be 30 mA for each LED
LFSR Source: http://en.wikipedia.org/wiki/Linear_feedback_shift_register
*/

#include<avr/io.h>
#define F_CPU 1200000UL
#include<util/delay.h>

int main(void)
{
	unsigned long lfsr = 1;
	unsigned char temp;
	DDRB= 0xff;

	while(1)
	{
		lfsr = (lfsr >> 1) ^ (-(lfsr & 1u) & 0xd0000001u); /* taps 32 31 29 1 */
		temp = (unsigned char) lfsr; //take lowermost eight bits

		DDRB= ~temp;//Declare those pins as output where temp is o
		PORTB =	temp;//Give the value of 0 to the pins declared output

		temp = (unsigned char) (lfsr >> 24);

		_delay_loop_2(temp<<7);
	} 

}


