/*
CHAPTER - 6 
Project 30 - RTTTL Player
*/

//Working code of rtttl player
#include<avr/io.h>
#include<avr/interrupt.h>
#include<avr/pgmspace.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include"ctype.h"

void play_rtttl_P(char *);

char song1[] PROGMEM = "Happy Birthday Song:d=4,o=5,b=125:8g.,16g,a,g,c6,2b,8g.,16g,a,g,d6,2c6,8g.,16g,g6,e6,c6,b,a,8f6.,16f6,e6,c6,d6,2c6,8g.,16g,a,g,c6,2b,8g.,16g,a,g,d6,2c6,8g.,16g,g6,e6,c6,b,a,8f6.,16f6,e6,c6,d6,2c6";
char song2[] PROGMEM = "MissionImp:d=16,o=6,b=95:32d,32d#,32d,32d#,32d,32d#,32d,32d#,32d,32d,32d#,32e,32f,32f#,32g,g,8p,g,8p,a#,p,c7,p,g,8p,g,8p,f,p,f#,p,g,8p,g,8p,a#,p,c7,p,g,8p,g,8p,f,p,f#,p,a#,g,2d,32p,a#,g,2c#,32p,a#,g,2c,a#5,8c,2p,32p,a#5,g5,2f#,32p,a#5,g5,2f,32p,a#5,g5,2e,d#,8d";
char song3[] PROGMEM = "Bond:d=4,o=5,b=80:32p,16c#6,32d#6,32d#6,16d#6,8d#6,16c#6,16c#6,16c#6,16c#6,32e6,32e6,16e6,8e6,16d#6,16d#6,16d#6,16c#6,32d#6,32d#6,16d#6,8d#6,16c#6,16c#6,16c#6,16c#6,32e6,32e6,16e6,8e6,16d#6,16d6,16c#6,16c#7,c.7,16g#6,16f#6,g#.6";
char song4[] PROGMEM = "BarbieGirl:d=4,o=5,b=125:8g#,8e,8g#,8c#6,a,p,8f#,8d#,8f#,8b,g#,8f#,8e,p,8e,8c#,f#,c#,p,8f#,8e,g#,f#";
char song5[] PROGMEM = "careaboutus::d=4,o=5,b=125:16f,16e,16f,16e,16f,16e,8d,16e,16d,16e,16d,16e,16d,16c,16d,d"; 
char song6[] PROGMEM = "KnightRider:d=4,o=5,b=63:16e,32f,32e,8b,16e6,32f6,32e6,8b,16e,32f,32e,16b,16e6,d6,8p,p,16e,32f,32e,8b,16e6,32f6,32e6,8b,16e,32f,32e,16b,16e6,f6,p";
char song7[] PROGMEM = "ScoobyDoo:d=4,o=5,b=160:8e6,8e6,8d6,8d6,2c6,8d6,e6,2a,8a,b,g,e6,8d6,c6,8d6,2e6,p,8e6,8e6,8d6,8d6,2c6,8d6,f6,2a,8a,b,g,e6,8d6,2c6";
char song8[] PROGMEM = "Stairway:d=4,o=5,b=63:8a6,8c6,8e6,8a6,8b6,8e6,8c6,8b6,8c7,8e6,8c6,8c7,8f#6,8d6,8a6,8f#6,8e6,8c6,8a6,c6,8e6,8c6,8a,8g,8g,8a,a";

unsigned int ch = 000;
unsigned char flag = 0,flag1=0;


ISR(PCINT_vect)
{   
	_delay_ms(10);	//debounce
	while(!(PINA&(1<<PA7)));	//wait for release
	_delay_ms(10);	//debounce

	flag = 1;
   	
}

int main(void)
{
	DDRA &= ~((1<<PA4)|(1<<PA5)|(1<<PA6)|(1<<PA7));//Input declared
	PORTA |= ((1<<PA4)|(1<<PA5)|(1<<PA6)|(1<<PA7));//Pull up Enabled
	
	GIMSK |= (1<<PCIE1);//PCINT7 general interrupt enable
	PCMSK0 |= (1<<PCINT7);//PCINT7 interrupt enable
	sei();
  	
	//song:
	
	while(1)
	{	
			
	if(flag)
	{
		
		flag = 0;
		flag1 = 1;
   		
		if(! (PINA & (1 << PA4)) )   // Switch 1 high
    		ch |= 0b001;

  		 else
			ch &= 0b110;
   
   		if ( ! (PINA & (1 << PA5)) )  // Switch 2 high
   			ch |= 0b010;

	    else
			ch &= 0b101;

   		if ( ! (PINA & (1 << PA6)) )  // Switch 3 pressed 
   			ch |= 0b100;
   	
   		else
			ch &= 0b011;
	}

	if(flag1)
	{
		DDRB  |= (1<<PB6);//output declared
		PORTB |= (1<<PB6);//Pull up Enabled
			
		switch(ch)
		{
			case 0b000:
				play_rtttl_P(song1);
				break;
			case 0b001:
				play_rtttl_P(song2);
				break;
			case 0b010:
				play_rtttl_P(song3);
				break;
			case 0b011:
				play_rtttl_P(song4);
				break;
			case 0b100:
				play_rtttl_P(song5);
				break;
			case 0b101:
				play_rtttl_P(song6);
				break;
			case 0b110:
				play_rtttl_P(song7);
				break;
			case 0b111:
				play_rtttl_P(song8);
				break;
		}
		DDRB  &= ~(1<<PB6);//output declared
		flag1=0;
	}
	}
}


void play_rtttl_P(char *p)
{
	// Defining Variables
	int default_dur = 4;
	int default_oct = 6;
	int bpm = 63;
	unsigned int num;
	unsigned int wholenote;
	unsigned int octave; 
	int note;
	unsigned int top[] = {0,118,112,105,99,94,88,83,79,74,141,133,126};
	int scale;
	int duration;
  

	// format: d=N,o=N,b=NNN:
  	// find the start (skip name, etc)
  	while(pgm_read_byte(p) != ':') 
  	p++;    					// skip ':'
  	p++;    					// Moving to 'd'

  	// get default duration
  	if(pgm_read_byte(p) == 'd')
  	{
 		p++; 			  // skip "d"
		p++;              // skip "="
    	num = 0;
    	while(isdigit(pgm_read_byte(p)))
    	{
      		num = (num * 10) + (pgm_read_byte(p++) - '0');
    	}
    	if(num > 0) 
			default_dur = num;
    	p++;                   // skip comma
  	}

 
  	// get default octave
  	if(pgm_read_byte(p) == 'o')
  	{
    	p++; 			  // skip "o"
		p++;              // skip "="
    	num = pgm_read_byte(p++) - '0';
    	if(num >= 4 && num <=8) 
			default_oct = num;
    	p++;                   // skip comma
  	}

  	// get BPM
  	if(pgm_read_byte(p) == 'b')
  	{
    	p++; 			  // skip "b="
		p++;              // skip "b="
    	num = 0;
    	while(isdigit(pgm_read_byte(p)))
    	{
      		num = (num * 10) + (pgm_read_byte(p++) - '0');
    	}
    
		bpm = num;
    	p++;                   // skip colon
  	}

 
 	// BPM usually expresses the number of quarter notes per minute
  	wholenote = 240000/bpm;  // this is the time for whole note (in milliseconds)

 	// now begin note loop
  	while(pgm_read_byte(p))
  	{
    	// first, get note duration, if available
    	num = 0;
    	while(isdigit(pgm_read_byte(p)))
    	{
      		num = (num * 10) + (pgm_read_byte(p++) - '0');
    	}
    
    	if(num) 
			duration = wholenote / num;			 //miliseconds of the time to play the note
    	else 
			duration = wholenote / default_dur;  // we will need to check if we are a dotted note after

	
		// now get the note
    	note = 0;

    	switch(pgm_read_byte(p))
    	{
      		case 'c':
        		note = 1;
        		break;
      		case 'd':
        		note = 3;
        		break;
      		case 'e':
        		note = 5;
        		break;
      		case 'f':
        		note = 6;
        		break;
      		case 'g':
        		note = 8;
        		break;
      		case 'a':
        		note = 10;
        		break;
      		case 'b':
        		note = 12;
        		break;
      		case 'p':
      		  	note = 0;
    	}
    p++;

 
  	// now, get optional '#' sharp
    if(pgm_read_byte(p) == '#')
    {
      note++;
      p++;
    }

    octave = top[note];
	
	// now, get optional '.' dotted note
    if(pgm_read_byte(p) == '.')
    {
      duration += duration/2;
      p++;
    }
  
    // now, get scale
    if(isdigit(pgm_read_byte(p)))
    {
      scale = pgm_read_byte(p) - '0';
      p++;
    }
    else
    {
      scale = default_oct;
    }

	 /* Process octave */
    switch (scale) 
		{
        case 4 : /* Do noting */			// x>>y = x/2*y
             break;
        case 5 : /* %2 */
             octave = octave >> 1; 
             break;
        case 6 : /* %4 */
             octave = octave >> 2;
             break;
        case 7 : /* %8 */
             octave = octave >> 4;
             break;
		case 8 : /* %16 */
             octave = octave >> 8;
             break;
		}

    
	if(pgm_read_byte(p) == ',')
      p++;       // skip comma for next note (or we may be at the end)

     // now play the note
	
	DDRB |= (1<<PB3);
		
	TCCR0A &= ~(1<<WGM00);	//Normal mode
	TCCR0B |= ((1<<CS02) | (1<<CS00));	//Prescalar 1024
		
	if(note)
	{
		
		TCCR1A |=  ((1<<COM1B1) | (1<<PWM1B));	//Non inverting mode, Fast PWM
		TCCR1B |=  ((1<<CS13) | (1<<CS10));		//Prescalar 256
		TCCR1C |= (1<<COM1B1);
		TCCR1D &=~((1<<WGM11) | (1<<WGM10));
		OCR1C = octave;
		OCR1B = (OCR1C>>1);
		TCNT0L = 0;
		
		for(;;)
		{
			if(flag)
				return;

			if(TCNT0L >= 78)
				{
					duration = duration - 10.0;
					TCNT0L = 0;
				}
			
			if(duration <= 0.00)
				break;	
		}
		TCCR0B = 0x00;
	}

	else
	{
		TCNT0L = 0;
		
		for(;;)

		{
			if(flag)
				return;

			if(TCNT0L >= 78)
				{
					duration = duration - 10.0;
					TCNT0L = 0;
				}
			if(duration <= 0.00)
				break;
		}
	
		TCCR0B = 0x00;
	}
  }	
  TCCR1A = 0x00;
  TCCR1B = 0x00;
}
