
/*
CHAPTER - 6 
Project 31 - Musical Toy
*/

/* **********************************************************************************************
This code is a simple musical memory game which has a set of 7 ( +1 for starting the game ) 
switches , 7 LEDs and two 7 segment display.It has a small piezo speaker that generates musical
notes. Press a switch and a note is produced and the corresponding LED glows for the duration 
of the note. Press another switch and another note is produced and another LED glows. Each switch 
and LED is associated with a unique note.

To begin with, the toy produces a random note when you press any switch, and the LED  associated 
with that note also glows. Then you regenerate that note by pressing one of the 7 switches. If you 
guessed right, the game proceeds to the next level and produces two notes.  7 segment displays the
current level of the game. On pressing the incorrect switch the game ends and the user needs to 
start with a new random note.
************************************************************************************************* */

#include<avr/io.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include<avr/interrupt.h>
#include "tone.h"
#define NUM 49  					//number of levels in the game

volatile unsigned char led[21],com=0,flag=7,level=1;

char pattern[NUM+1],u,t;
int j=0,count=0;

void initialise(void)
{
	DDRB|= (1<<PB6)|(1<<PB5)|(1<<PB4)|(1<<PB3);
	PORTB|=(1<<PB7)|(1<<PB6)|(1<<PB5)|(1<<PB4)|(1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0);
	DDRA|= (1<<PA7)|(1<<PA6)|(1<<PA5)|(1<<PA4)|(1<<PA3)|(1<<PA2)|(1<<PA1)|(1<<PA0);
	PORTA|=(1<<PA7)|(1<<PA6)|(1<<PA5)|(1<<PA4)|(1<<PA3)|(1<<PA2)|(1<<PA1)|(1<<PA0);
}
void timer0init(void)        // timer0
{	
	TCCR0A=0x00;
	TCCR0B=1<<CS01;      //prescale by 8
	TIMSK=1<<TOIE0;      //enables overflow interrupt
	
}
void ledoff(void)			//switching off all leds and display
{	int i;
	for(i=0;i<=20;i++)
	led[i]=0;			
}
void ledinit(int num,int num1,int num2) //switches on the leds according to the parameters paased
{	int i;		
	ledoff();

	switch(num)		
	{ default:
	  case 0:led[14]=1;
			break;
	  case 1:led[15]=1;
			break;
	  case 2:led[16]=1;
			break;
	  case 3:led[17]=1;
			break;
	  case 4:led[18]=1;
  			break;
   	  case 5:led[19]=1;
			break;
	  case 6:led[20]=1;
			break;
	}
		
	switch(num1)		//switches on seven segment display 1
	{ default:ledoff();
			 led[6]=1;
			 break;
	  case 0:for(i=0;i<=5;i++)
			 led[i]=1;			
			 break;
	  case 1:led[1]=led[2]=1;
			 break;
	  case 2:led[0]=led[1]=led[3]=led[4]=led[6]=1;
			 break;
	  case 3:led[0]=led[1]=led[3]=led[2]=led[6]=1;
			 break;
	  case 4:led[1]=led[2]=led[5]=led[6]=1;
  			 break;
   	  case 5:led[0]=led[2]=led[3]=led[5]=led[6]=1;
			 break;
	  case 6:for(i=0;i<=6;i++)
			 {	if(i==1)
				continue;
				led[i]=1;
			 }
			 break;
	  case 7:led[0]=led[1]=led[2]=1;
			 break;
	  case 8:for(i=0;i<=6;i++)
	  			led[i]=1;
			 break;
	  case 9:for(i=0;i<=6;i++)
			 {	if(i==4)
				continue;
				led[i]=1;
			 }
			 break;
	}
	
	switch(num2)			//switches on seven segment display 2
	{ default: led[13]=1;
				break;
	  case 0:for(i=0;i<=5;i++)
			 led[i+7]=1;			
			 break;
	  case 1:led[8]=led[9]=1;
			 break;
	  case 2:led[7]=led[8]=led[10]=led[11]=led[13]=1;
			 break;
	  case 3:led[7]=led[8]=led[10]=led[9]=led[13]=1;
			 break;
	  case 4:led[8]=led[9]=led[12]=led[13]=1;
  			 break;
   	  case 5:led[7]=led[9]=led[10]=led[12]=led[13]=1;
			 break;
	  case 6:for(i=0;i<=6;i++)
			 {	if(i==1)
				continue;
				led[i+7]=1;
			 }
			 break;
	  case 7:led[7]=led[8]=led[9]=1;
			 break;
	  case 8:for(i=0;i<=6;i++)
	  			led[i+7]=1;
			 break;
	  case 9:for(i=0;i<=6;i++)
			 {	if(i==4)
				continue;
				led[i+7]=1;
			 }
			 break;			

   }
   	
}

void lfsr(unsigned char randum) //linear feedback shift register
{	unsigned char k;				//generates random numbers
	k=randum%7;	   				//generate number from 0-6
	pattern[j]=k;  				// stores all the random numbers in the array each time the game is restarted.
	j++;	
}

ISR(TIMER0_OVF_vect)
{	
	//switch scanning 
	//the 7 switches are connected in a 3 X 3 matrix keypad arrangment
	PORTB=~(1<<PB4);
	PORTA=0xFF;		
		if(!(PINB&(1<<PB1)))
			{					
				while(!(PINB&(1<<PB0))); //Switch 1 pressed
				flag=0;				
			}						
		 if(!(PINB&(1<<PB0)))
			{				
				while(!(PINB&(1<<PB1))); //Switch 2 pressed
				flag=1;							
			}			
		if(!(PINB&(1<<PB2)))
			{			
				while(!(PINB&(1<<PB2))); //Switch 3 pressed
				flag=2;					
			}				
		
	PORTB=~(1<<PB5);
		if(!(PINB&(1<<PB1)))
			{					
				while(!(PINB&(1<<PB0))); //Switch 4 pressed
				flag=3;													
			}
			if(!(PINB&(1<<PB0)))
			{				
				while(!(PINB&(1<<PB1))); //Switch 5 pressed
				flag=4;							
			}
			if(!(PINB&(1<<PB2)))
			{	
				while(!(PINB&(1<<PB2))); //Switch 6 pressed
				flag=5;				
			}				
		
	PORTB=~(1<<PB6);
		if(!(PINB&(1<<PB0)))
			{	
				while(!(PINB&(1<<PB0))); //Switch 7 pressed
				flag=6;							
			}		
		
	
	//multiplexing
	// leds are switched on if led[i]=1
	com++;
	switch(com)
	{	case 1:	PORTA=0b11111111;
				PORTB=~(1<<PB4);				
				for(int i=0;i<=6;i++)			
				{	switch(i)
					{	case 0:	if(led[i]==1)
							   	PORTA&=~(1<<PB5);
							   	break;
						case 1:	if(led[i]==1)
								PORTA&=~(1<<PB6);
								break;
						case 2:	if(led[i]==1)
								PORTA&=~(1<<PB0);
								break;
						case 3:	if(led[i]==1)
								PORTA&=~(1<<PB1);
								break;
						case 4:	if(led[i]==1)
								PORTA&=~(1<<PB2);
								break;
						case 5:	if(led[i]==1)
								PORTA&=~(1<<PB4);
								break;
						case 6:	if(led[i]==1)
								PORTA&=~(1<<PB3);
								break;
					}
				}				
				break;
		case 2:	PORTA=0b11111111;
				PORTB=0b11011111;				
				for(int i=7;i<=13;i++)
				{	switch(i-7)			
					{	case 0:	if(led[i]==1)
							   	PORTA&=~(1<<PB5);
							   	break;
						case 1:	if(led[i]==1)
								PORTA&=~(1<<PB6);
								break;
						case 2:	if(led[i]==1)
								PORTA&=~(1<<PB0);
								break;
						case 3:	if(led[i]==1)
								PORTA&=~(1<<PB1);
								break;
						case 4:	if(led[i]==1)
								PORTA&=~(1<<PB2);
								break;
						case 5:	if(led[i]==1)
								PORTA&=~(1<<PB4);
								break;
						case 6:	if(led[i]==1)
								PORTA&=~(1<<PB3);
								break;
					}
				}
				break;
		case 3:	PORTA=0b11111111;
				PORTB=0b10111111;				
				for(int i=14;i<=20;i++)
				{	switch(i)
					{	case 14:if(led[i]==1)
						PORTA=~(1<<PB6);
						break;
						case 15:if(led[i]==1)
						PORTA=~(1<<PB0);
						break;
						case 16:if(led[i]==1)
						PORTA=~(1<<PB5);
						break;
						case 17:if(led[i]==1)
						PORTA=~(1<<PB4);
						break;
						case 18:if(led[i]==1)
						PORTA=~(1<<PB3);
						break;
						case 19:if(led[i]==1)
						PORTA=~(1<<PB2);
						break;
						case 20:if(led[i]==1)
						PORTA=~(1<<PB1);
						break;
					}
				}	
				com=0;
				break;
			
	}	
}

void checktone(int n) //checks if correct sequence of tones is being played
{	
	toneon(n);
	if(n==pattern[count]) // if the correct switch is pressed
	{	ledinit(n,u,t);
		count++;
		
	}
	else				 //incorrect switch is pressed
	{	
		while(1)
		{
		ledinit(0,10,10); // displays a dash line on the 7 segment display
		
		}
	}
	
	
}
int main(void)
{	
	int i;
	timer0init();
	initialise();
	sei();
	while(1)
	{		DDRB= (1<<PB6)|(1<<PB3);
			if(!(PINB&(1<<PB1)))	//waits for main switch to be pressed to start the game
			{	_delay_ms(10);
				while(!(PINB&(1<<PB1)));
				_delay_ms(10);
				DDRB|=(1<<PB4)|(1<<PB5);
				while(j<=NUM)
					lfsr(TCNT0L);
				
				while(1)
				{	u=level%10;
					t=level/10;
					for(i=0;i<level;i++)
					{	toneon(pattern[i]);
						ledinit(pattern[i],u,t);
						_delay_ms(200);
						toneoff();
						_delay_ms(50);					
					}
					for(i=14;i<=20;i++)
						led[i]=0;
		
	 				while(count<level)
					{	if(flag!=7)
						{	checktone(flag);
							flag=7;
							_delay_ms(200);
							toneoff();		 
						}
					}
					_delay_ms(500);	
					level++;	//takes the game to the next level
					count=0;	
	
				}

		}
	}
}	
