#ifndef tone
#define tone


#define sa 133   // 240Hz
#define re 118	 // 270Hz
#define ga 106	 // 300Hz
#define ma 100	 // 320Hz
#define pa  89	 // 360Hz
#define dha 80	 // 400Hz
#define ni  71	 // 4500Hz
#define dc  0.75 //duty cycle
#define  g5  40  // 784Hz   
#define  f5  45  // 698Hz
#define  e5  47  // 659Hz
#define  d5  53  // 587Hz
#define  c5  60  // 523Hz
#define  d    4	 //duration of the frequency
#define  o    5	 //octave
#define  b   125 // default beats/tempo   



void timer1init(void)
{	   
    TCCR1A|=(1<<PWM1B)|(1<<COM1B1);//enables PWM
    TCCR1B|=(1<<CS13)|(1<<CS10);//prescaling by 256
	
	
}

void toneon(int N)
{	timer1init();

	switch(N)
	{	default:
		case 0: OCR1C=sa;//Sa 240Hz
			OCR1B=dc*OCR1C;
			break;
		case 1: OCR1C=re;//Re 270Hz
			OCR1B=dc*OCR1C;
			break;
		case 2: OCR1C=ga;//Ga 300Hz
			OCR1B=dc*OCR1C;									
			break;
		case 3: OCR1C=ma;//Ma 320Hz
			OCR1B=dc*OCR1C;
			break;
		case 4: OCR1C=pa;//Pa 360Hz
			OCR1B=dc*OCR1C;
			break;
		case 5: OCR1C=dha;//Dha 400Hz
			OCR1B=dc*OCR1C;
			break;
		case 6: OCR1C=ni;///Ni 450Hz
			OCR1B=dc*OCR1C;
			break;
	
	}

}

void toneoff(void)
{	
	TCCR1A=0x00;
}


#endif
