#ifndef REMOTE_H
#define REMOTE_H

/*************************************************
* REMOTE PROTOCOL
*************************************************/

#define SIRCS								//Select remote protocol || RC5 || SIRCS || SAMSUNG || NEC			

/*************************************************
* REMOTE FORMATS
*************************************************/

/*************************************************
* RC5 FORMAT
*************************************************/

#define	RC5_ON_PERIOD_ZERO					889
#define	RC5_OFF_PERIOD_ZERO					889

#define	RC5_ON_PERIOD_ONE					889
#define	RC5_OFF_PERIOD_ONE					889

/*************************************************
* SIRCS FORMAT
*************************************************/

#define	SIRCS_START_BIT_ON_PERIOD			2400
#define	SIRCS_START_BIT_OFF_PERIOD			600

#define	SIRCS_ON_PERIOD_ZERO				600
#define	SIRCS_OFF_PERIOD_ZERO				600

#define	SIRCS_ON_PERIOD_ONE					1200
#define	SIRCS_OFF_PERIOD_ONE				600

/*************************************************
* SAMSUNG FORMAT
*************************************************/

#define	SAMSUNG_START_BIT_ON_PERIOD			4500
#define	SAMSUNG_START_BIT_OFF_PERIOD		4500

#define	SAMSUNG_ON_PERIOD_ZERO				560
#define	SAMSUNG_OFF_PERIOD_ZERO				560

#define	SAMSUNG_ON_PERIOD_ONE				560
#define	SAMSUNG_OFF_PERIOD_ONE				1690

#define	SAMSUNG_STOP_BIT_ON_PERIOD			560
#define	SAMSUNG_STOP_BIT_OFF_PERIOD			1690

/*************************************************
* NEC FORMAT
*************************************************/

#define	NEC_START_BIT_ON_PERIOD				9000
#define NEC_START_BIT_OFF_PERIOD			4500

#define	NEC_ON_PERIOD_ZERO					560
#define	NEC_OFF_PERIOD_ZERO					560

#define	NEC_ON_PERIOD_ONE					560
#define	NEC_OFF_PERIOD_ONE					1690

#define	NEC_STOP_BIT_ON_PERIOD				560
#define	NEC_STOP_BIT_OFF_PERIOD				1690

/*************************************************
* FUNCTION DECLARATION
*************************************************/

void determine_pin_RC5(void);											//Pin determine function for RC5 protocol
void determine_pin_Samsung(void);										//Pin determine function for SAMSUNG protocol
void determine_pin_SIRCS(void);											//Pin determine function for SIRCS protocol
void determine_pin_NEC(void);											//Pin determine function for NEC protocol

void transmit_RC5(void);												//Transmit function for RC5 protocol
void transmit_SIRCS(void);												//Transmit function for SIRCS protocol
void transmit_Samsung(void);											//Transmit function for SAMSUNG protocol
void transmit_NEC(void);												//Transmit function for NEC protocol

/*************************************************
* Public Constants
*************************************************/

#define IR_LED				PB1

#define COLUMN_1			PB0
#define COLUMN_2			PB5

#define ROW_1				PB2
#define ROW_2				PB3
#define ROW_3				PB4

/*************************************************
* GLOBAL VARIABLE DECLARATION
*************************************************/

char New_Key_Pressed = 0,Tx = 0, Tx_bit_RC5[14], Tx_bit_SIRCS[12], Tx_bit_Samsung[32], Tx_bit_NEC[32];	
int i = 0,j = 0;



#endif 
