/*
CHAPTER - 7 
Project 34 - Batteryless Persistence-of-Vision Toy
*/

#include<avr/interrupt.h>
#include<avr/io.h>
#include<avr/delay.h>
#include<avr/pgmspace.h>
//                        {<--------------------H----------------->              <-----------------------E-------->             <----------------L--------------->               <----------------L--------------->                                                                     
//const char MSG[] PROGMEM= {0x80, 0x80, 0xe3, 0xe3, 0xe3, 0x80, 0x80, 0xff, 0xff, 0x80, 0x80, 0xb6, 0xb6, 0xbe, 0xbe, 0xff, 0xff,0x80, 0x80, 0xbf, 0xbf, 0xbf, 0xbf, 0xff, 0xff, 0x80, 0x80, 0xbf, 0xbf, 0xbf, 0xbf, 0xff, 0xff, 0xe3, 0xc1, 0xbe, 0xbe, 0xbe, 0xc1, 0xe3};
//40 bytes


//Make: SPECTRUM
//const char MSG[] PROGMEM= {0x80, 0xfd, 0xfb, 0xf7, 0xfb, 0xfd, 0x80, 0xff, 0xdb, 0xad, 0xba, 0xba, 0xb3, 0xc7, 0xff, 0x80, 0xf7, 0xeb, 0xdd, 0xbe, 0xff, 0xe3, 0xcd, 0xad, 0xad, 0xb3, 0xff, 0xff, 0xff, 0x93, 0x93, 0xff, 0xff, 0xd9, 0xb6, 0xb6, 0xb6, 0xcd, 0xff, 0x80, 0xf6, 0xf6, 0xf6, 0xf9, 0xff, 0x80, 0xb6, 0xb6, 0xbe, 0xbe, 0xff, 0xc1, 0xbe, 0xbe, 0xbe, 0xdd, 0xff, 0xfe, 0xfe, 0x80, 0xfe, 0xfe, 0xff, 0x80, 0xf6, 0xe6, 0xd6, 0xb9, 0xff, 0xc0, 0xbf, 0xbf, 0xbf, 0xc0, 0xff, 0x80, 0xfd, 0xfb, 0xf7, 0xfb, 0xfd, 0x80};
//size: 83 bytes


//Make: H
const char MSG[] PROGMEM= {0x80, 0xfd, 0xfb, 0xf7, 0xfb, 0xfd, 0x80, 0xff, 0xdd, 0xae, 0xb6, 0xb6, 0xb9, 0xc3, 0xbf, 0xff, 0x80, 0xf7, 0xeb, 0xdd, 0xbe, 0xff, 0xe3, 0xcd, 0xad, 0xad, 0xb3, 0xff, 0xff, 0x93, 0x93, 0xff, 0xf3, 0xe1, 0xc0, 0xc0, 0xc1, 0x87, 0x87, 0xc1, 0xc0, 0xc0, 0xe1, 0xf3, 0xff, 0xff};
//size: 45 bytes


//const char MSG[] PROGMEM= {0x01, 0x01, 0xc7, 0xc7, 0xc7, 0x01, 0x01, 0xff, 0xff, 0x01, 0x01, 0x6d, 0x6d, 0x7d, 0x7d, 0xff, 0xff,0x01, 0x01, 0x6d, 0x6d, 0x7d, 0x7d, 0xff, 0xff, 0x01, 0x01, 0xfe, 0x7f, 0x7f, 0x7f, 0xff, 0xff, 0xe3, 0xc1, 0xbe, 0xbe, 0xbe, 0xc1, 0xe3};


#define maxchar 45
//Bitwise Definition:

/* 18thFeb 2007
tried to program the Tiny24 using 6-pin ISP through STK500
failed first time.. turned out that Build 460 of STudio4 was the culprit
upgraded to Build 498 which also upgraded the firmware on STK500 board
now the Tiny24 programs OK*/

/*23rd Feb: Added Hall Sensor part on PA7*/

/*5th March: removed Hall Sensor, added reed switch. same function as hall sensor*/

void main(void)
{
unsigned char temp;

DDRA= 0x7f;
PORTA=255;


for(;;)
{
PORTA = 255;

while( (PINA&0x80) == 0x80);

while( (PINA&0x80) == 0);

		_delay_loop_2(3000);
while( (PINA&0x80) == 0);

_delay_loop_2(1000);	
	for(temp=0; temp<maxchar; temp++)
		{
		PORTA= pgm_read_byte(&MSG[temp]);
		_delay_loop_2(150);
		PORTA=0xff;
		_delay_loop_2(50);
		}
	}

}
