
/*
Chapter - 2
Project - 5 LEDpen

*/

#include<avr/io.h>
#include<avr/interrupt.h>
#define F_CPU 1200000UL
#include<util/delay.h>
#include<avr/pgmspace.h>
#include<avr/sleep.h>





//Prototypes

//This function is called to switch on the LED at the 
//Required stage of PWM cycle
void abc(unsigned char a,unsigned char b,unsigned char c,unsigned char status);

//This function is used to initialise the new PWM cycle
void xyz(void);


volatile unsigned char e;
volatile unsigned char pwm[3]={0,8,8};
volatile unsigned char i=0;
volatile unsigned char k=0;
//PWM scale 0 - On 8 OFF
const unsigned char Blue[15] PROGMEM =  {0,8,8,0,0,8,0,6,2,3,6,1,4,5,7};
const unsigned char Red[15] PROGMEM =   {8,0,8,2,8,2,0,5,5,5,6,6,6,7,7};
const unsigned char Green[15] PROGMEM = {8,8,0,8,0,0,0,2,0,6,4,2,7,0,2};
volatile unsigned int counter =0;




int main(void)
{


	DDRB  &= ~((1<<3)|(1<<4)); //Switches and ADC
	PORTB |= (1<<3); //Switches
	PCMSK = 1<<PCINT3;//Configure PB3 as interrupt
	
	//ADC init
	
	ADMUX =  0b00100010; //ADC2,ADLAR,VCc
	ADCSRA = 0b10000010; //prescaled by 4
	
	//neglect first reading
	ADCSRA |= 1<<ADSC;
	while(ADCSRA&(1<<ADSC));//Wait
	i = ADCH;
	
	//Timer Initialisation
	TCCR0A = 0x00;
	TCCR0B = 0x02;//Prescaling
	TIMSK0 = 1<<TOIE0;//Overflow Interrupt Enabled
	sei();//Global Interrupts Enabled

	while(1)
	{
			
			
		i=0;
	
	
		ADCSRA |= 1<<ADSC;
		while(ADCSRA&(1<<ADSC));//Wait
		i = ADCH;
		
		
		
		i = i>>4;//Divide by 16
		if(i!=15)
		{
			pwm[0] = pgm_read_byte(&Blue[i]);
			pwm[1] = pgm_read_byte(&Red[i]);
			pwm[2] = pgm_read_byte(&Green[i]);
			counter = 0;
			k = 0;
		}
		_delay_ms(2);//Just a small delay
				
			
		
		if(!(PINB&(1<<3)))
		{
			_delay_ms(30);
			while(!(PINB&(1<<3))); //wait
			_delay_ms(30);
			
			
			TIMSK0 &= ~(1<<TOIE0);//Clear timer interrupt
			DDRB &=~(1<<0|1<<1|1<<2);
			GIFR |= 1<<PCIF;//Clear pending interrupt
			GIMSK |= 1<<PCIE;//Pin change interrupt enable
			MCUCR |= (1<<SE|1<<SM1);//Power down mode setting
			sleep_cpu(); //CPU halted till interrupt
			
		}
	
	}

	

}



ISR(TIM0_OVF_vect)
{
	
	
	DDRB &=~(1<<0|1<<1|1<<2);
	
	
	
	if(e==8)
	{
		e=0;
		xyz();
	}

	abc(pwm[0],pwm[1],pwm[2],e);
	DDRB |=(1<<0|1<<1|1<<2);
	e++;
	if(i==15)//Run mode
	{
		counter++;
		if(counter == 390)//500ms
		{
			counter = 0;
			if(k==14)
			k=0;
			else k++;
			pwm[0] = pgm_read_byte(&Blue[k]);
			pwm[1] = pgm_read_byte(&Red[k]);
			pwm[2] = pgm_read_byte(&Green[k]);
		}
	}
	
}

void xyz(void)
{
	
	PORTB |= (1<<0)|(1<<1)|(1<<2);
	
	
}


void abc(unsigned char a,unsigned char b,unsigned char c,unsigned char status)
{

	if((status==a))
	{
		PORTB&= ~(1<<0);
	}
	if((status==b))
	{
		PORTB&= ~(1<<1);
	}
	if((status==c))
	{
		PORTB&= ~(1<<2);
	}
	
}

ISR(PCINT0_vect)
{
	_delay_ms(30);
	while(!(PINB&(1<<3))); //wait
	_delay_ms(30);
	MCUCR = 0x00; //sleep disable
	GIMSK &= ~(1<<PCIE);//Pin change interrupt disable
	TIMSK0 = 1<<TOIE0;//Overflow Interrupt Enabled
			
			

}



