
/*

Chapter - 3
Project - 6 RGB moodlamp
*/

/*
This project uses three channels of hardware PWM
*/

#include<avr/io.h>
#include<avr/interrupt.h>
#define F_CPU 8000000UL
#include<util/delay.h>
#include<avr/pgmspace.h>


#define DISCRETE 1
#define CONTINUOUS 2

volatile unsigned char mode = CONTINUOUS;
volatile unsigned char i,j,k;

int main(void)
{

	//Timer Initialisation
	TCCR1A = 0b10100011; //Pwm on A and B enabled with non inverting mode
	TCCR1B = 0b00000100;// prescaling by 8
	TCCR1C = 0b10101001;//Pwm on D enabled with non inverting mode;
	TCCR1D = 0b00000000;//Fast PWM
	OCR1C = 31; //only thirty two levels desired
	
	//Initial value;
	OCR1A = 0x00;
	OCR1B = 0x00;
	OCR1D = 0x00;
	
	//PWM
	DDRB |= 1<<1|1<<3|1<<5;
	
	//LED
	DDRA |= 1<<7;
	PORTA &= ~(1<<7);//LED off for continuous
	
	//Switches
	DDRA &= ~(1<<5)|(1<<6);
	PORTA |= (1<<5)|(1<<6);
	PCMSK0 = 1<<PCINT6;
	PCMSK1 = 0;
	GIMSK = 1<<PCIE1;//Pin change interrupt enable
	sei();
	
	
	while(1)
	{
		
		
		for(i=0;i<32;i++)
		{
			OCR1A = i;
			for(j=0;j<32;j++)
			{
				OCR1B = j;
				for(k=0;k<32;k++)
				{
					OCR1D = k;
					if(mode==CONTINUOUS)
					_delay_ms(500);
					else if(mode==DISCRETE)
					{
						while((PINA&(1<<5))&&(mode==DISCRETE));//wait
						_delay_ms(30);
						while((!(PINA&(1<<5)))&&(mode==DISCRETE));//wait
						_delay_ms(30);
					}
				}
			}
		}
	}
	


}

ISR(PCINT_vect)
{
	
	_delay_ms(30);//debounce
	GIFR  = 1<<PCIF;//Clear flag set due to switch bounce
	mode = mode==CONTINUOUS?DISCRETE:CONTINUOUS;
	
	if(mode==CONTINUOUS)
	PORTA&=~(1<<7);//LED off
	else
	PORTA|=(1<<7);//LED on		
	
	
			

}	
